*
***********************************************************************
*
*  THE FORMAT OF THE EDX ASSEMBLER WORK AREA IS DEFINED
*  BY THE FOLLOWING EQUATE TABLE
*
*     EDITED MAR 25, 13:20
***********************************************************************
*
OPCODE	 EQU   0	      8 CHARACTER OPERATION CODE
LOCCNTR  EQU   OPCODE+8       LOCATION COUNTER (1 WORD)
STMNTNO  EQU   LOCCNTR+2      CURRENT SOURCE STATEMENT NUMBER
LINENO	 EQU   STMNTNO+2      CURRENT SOURCE LINE NUMBER
HERRCODE EQU   LINENO+2       HIGHEST SEVERITY (ERROR) CODE
ALABEL	 EQU   HERRCODE+2     ADDRESS OF LABEL SUBLIST ELEMENT
AOPCHECK EQU   ALABEL+2       ADDRESS OF OPERAND CHECK SUBROUTINE
AOPTABLE EQU   AOPCHECK+2     ADDRESS OF OPERAND TABLE
ABLDTXT  EQU   AOPTABLE+2     ADDRESS OF OBJECT TEXT BUILD SUBROUTINE
AGETVAL  EQU   ABLDTXT+2      ADDRESS OF SUBROUTINE TO EVALUATE A TERM
ASLPARSE EQU   AGETVAL+2      ADDRESS OF SUBLIST PARSE SUBROUTINE
ASLPARS4 EQU   ASLPARSE+2     ADDRESS OF EXPRESSION PARSE SUBROUTINE
AGLOBALS EQU   ASLPARS4+2     ADDRESS OF 258 BYTE GLOBAL
*			      WORK AREA.  BYTES 0 & 1 = REC. NO.
*			      OF CURRENT IN STORAGE GLOBAL RECORD.
*
*			      BYTES 2-257 = GLOBALS I/O BUFFER.
*
AMACDATA EQU   AGLOBALS+2     ADDRESS OF FIRST BYTE OF DATA
*			      RETURNED FROM MACRO PROCESSING.
ACMDTABL EQU   AMACDATA+2     ADDRESS OF LANGUAGE COMMAND TABLE
SOURCENO EQU   ACMDTABL+2     SOURCE DATA SET SWITCH
*			       0 = READING PRIMARY DATA SET
*			       .GT. 0 = READING ALTERNATE DATA SET
AASMDS1  EQU   SOURCENO+2     ADDRESS OF FIRST 'DSCB' IN MAINLINE PGM.
SAVEDSCB EQU   AASMDS1+2      4 WORD SAVE AREA FOR CONTROL INFORMATION
*			      FOR PRIMARY 'DSCB'
SOURCESW EQU   SAVEDSCB+8     FIRST OR SECOND RECORD SWITCH FOR
*			      SOURCE DATA SET
SAVESSW  EQU   SOURCESW+2     SAVE AREA FOR 'SOURCESW' WHEN USING
*			      AN ALTERNATE SOURCE DATA SET
ALABELS  EQU   SAVESSW+2      ADDRESS OF 'LABELS' SUBROUTINE
#ERRMSGS EQU   ALABELS+2      NUMBER OF STATEMENTS FLAGGED
LISTSW	 EQU   #ERRMSGS+2     =0 SUPPRESS OUTPUT LISTING
*			      =1 PRINT OUTPUT LISTING
ATYPEOP  EQU   LISTSW+2       ADDRESS OF 'TYPE' SUBROUTINE
$SYSNDX  EQU   ATYPEOP+2      ASSEMBLER '&SYSNDX'
#TIMDAT1 EQU   $SYSNDX+2      TIME ASSEMBLY STARTED
#TIMDAT2 EQU   #TIMDAT1+4     TIME ASSEMBLY ENDED
#TIMDAT3 EQU   #TIMDAT2+4     TIME AND DATE OF ASSEMBLY
#CMDHASH EQU   #TIMDAT3       CURRENT COMMAND HASH VALUE	  V3M0A
CSECTNAM EQU   #TIMDAT3+12    SECTION DEFINITION
#PNTFREE EQU   CSECTNAM+8     NEXT AVAILABLE ESD RECORD
#$PARM1  EQU   #PNTFREE+2     POINTER TO PARAMETER INPUT AREA
#AINBUF  EQU   #$PARM1+2      POINTER TO INPUT BUFFER
#CONFIG  EQU   #AINBUF+2      'SYSTEM' MACRO FLAG
#TERMCOM EQU   #CONFIG+2      'TERMINAL' COMMON AREA
#$ID	 EQU   #TERMCOM+2     $ID IN FORM 'VMLP'		   V3M1
#ERRMSG  EQU   #$ID+2	      ERROR MESSAGE # FROM LABELS	   V3M1
LOADVOL# EQU   #ERRMSG+2      $EDXASM PROGRAM LOAD VOLUME	   V3M1
*
*  NEXT EQUATE MUST HAVE VALUE 'LOADVOL#+6'
*
	 EJECT
	 SPACE 3
*
*  THE FORMAT OF THE STATEMENT PROCESSOR OUTPUT IS AS FOLLOWS:
*
*	 A 1 WORD COUNT OF THE NUMBER OF OBJECT TEXT ELEMENTS
*	 BEING RETURNED FROM THE PROCESSOR.
*
*	 THIS IS THEN FOLLOWED BY AS MANY OBJECT TEXT ELEMENTS
*	 AS WERE PRODUCED BY THE PROCESSOR.
*
*	 THE FORMAT OF AN 'OBJECT TEXT ELEMENT' IS:
*
OTETYPE  EQU   0	      TYPE OF OBJECT TEXT ELEMENT (SEE BELOW)
OTEDATAC EQU   OTETYPE+2      LENGTH OF 'OTE' DATA IN BYTES
OTEDATAP EQU   OTEDATAC+2     ADDRESS OF DATA SUBLIST ELEMENT
*			      OR DATA
OTEDATAL EQU   OTEDATAP+2     ADDRESS OF LABEL SUBLIST ELEMENT OR '0'
LOTE	 EQU   OTEDATAL+2     LENGTH OF AN 'OTE'
*
*
*  THE DEFINED TYPES OF 'OBJECT TEXT ELEMENTS' ARE:
*
#NULL	 EQU   0	      NULL 'OTE'
#OPCODE  EQU   1	      DATA IS AN OPERATION CODE
#ADDRESS EQU   2	      DATA IS AN ADDRESS
#ERROR	 EQU   3	      'OTE' IS AN ERROR MESSAGE
#INDXREG EQU   4	      'OTE' DEFINES AN INDEX REGISTER
#FCON	 EQU   5	      'OTE' DATA WORD CONTAINS A FULL WORD
*				CONSTANT
#DATA	 EQU   6	      'OTE' DEFINES DATA, EG. A CHARACTER
*				STRING
#EQUATE  EQU   7
#COPYSW  EQU   8	      'OTE' DEFINES ALTERNATE 'DSCB' INFO
#EXTRN	 EQU   9
#WXTRN	 EQU  10
#ENTRY	 EQU  11
	 SPACE 3
*  FOR EACH DEFINED LABEL AN ENTRY IS MADE IN THE 'SYMBOL TABLE'
*  THE FOLLOWING SYMBOL TABLE TYPES ARE DEFINED
*
#ISDADR  EQU	   X'8000'	       ADDRESS
#ISDEQU  EQU	   X'4000'	       EQUATE
#ISDEXT  EQU	   X'0200'	       EXTRN
#ISDWXT  EQU	   X'0A00'	       WXTRN
#ISDENT  EQU	   X'0100'	       ENTRY
	 EJECT
	 SPACE 3
*
*  THE FOLLOWING DEFINES THE HEADER OF THE OPERAND LIST AS SET UP
*  BY THE PARSE ROUTINES
*
#POSIT	 EQU	   0		       NO. OF POSITIONAL PARAMETERS
#KEYWD	 EQU	   #POSIT+2	       NO. OF KEYWORDS SPECIFIED
*
*  THE FOLLOWING DEFINES AN OPERAND LIST ELEMENT (OLE) AS SET UP BY
*  THE PARSE ROUTINES
*
OLEDATA  EQU   0	     POINTER TO THE FIRST BYTE OF OPERAND TEXT
OLELENG  EQU   OLEDATA+2     THE LENGTH OF THE OPERAND FIELD IN
*			     BYTES
OLESLE	 EQU   OLELENG+2     THE ADDRESS OF THE FIRST OPERAND
*			     SUBLIST ELEMENT
OLESLE#  EQU   OLESLE+2      THE NUMBER OF OPERAND SUBLIST ENTRIES
OLEKEYWD EQU   OLESLE#+2     THE ADDRESS OF AN EIGHT CHARACTER
*			     KEYWORD OR '0' IF NONE
LOLE	 EQU   OLEKEYWD+2    LENGTH OF OPERAND LIST ELEMENT
*			      KEYWORD FIELD IF THIS IS A KEYWORD
*			      OPERAND.
*
*			      IF THIS IS A POSITIONAL OPERAND, THIS
*			      WORD IS '0'.
*
*
*  THE FOLLOWING DEFINES THE FIELDS IN AN OPERAND SUBLIST ELEMENT
*
SLEDATA   EQU	0	      THE ADDRESS OF THE FIRST CHARACTER
*			      OF THE ASSOCIATED OPERAND SUBLIST ELEMENT
SLELENG  EQU   SLEDATA+2      THE NUMBER OF CHARACTERS IN THE
*			      OPERAND SUBLIST ELEMENT
SLETYPE  EQU   SLELENG+2      TYPE INDICATOR (SEE DEFINITIONS BELOW)
SLECODE  EQU   SLETYPE	      CHAIN CODE INDICATOR (1=+,2=-,3=*,4=/)
SLECHAIN EQU   SLETYPE+2      POINTER TO CHAINED SLE
LSLE	 EQU   SLECHAIN+2
*
*
*  THE FOLLOWING OPERAND TYPES ARE DEFINED:
*
SELFDEF  EQU   1	      SELF DEFINING TERM
STRING	 EQU   2	      CHARACTER STRING
