	 SUBROUT   $INDEX,#OP,#OPWORD,OTE#,OP#
*
*  $INDEX EXAMINES AN OPERAND FIELD FOR INDEX REGISTER SPECIFICATION
*  AND STORES CONTROL INFORMATION ACCORDINGLY.
*
*  INPUT
*	 '#OP'	   ADDRESS OF THE OPERAND LIST ELEMENT (OLE) OF THE
*		   OPERAND BEING PROCESSED.
*
*	 '#OPWORD' THE OPERATION-CODE WORD INTO WHICH INDEX REGISTER
*		   USAGE INDICATORS MAY BE SET.
*
*	 'OTE#'    THE ADDRESS OF THE OBJECT TEXT ELEMENT (OTE) TO
*		   BE SET TO REFLECT THE NATURE OF THE INPUT OPERAND.
*
*	 'OP#'	   THE SEQUENCE NUMBER (1, 2, OR 3) OF THE INPUT
*		   OPERAND.
*
*
*  OUTPUT
*
*	 NORMAL AND OPERAND HAS ONLY ONE SUBLIST ELEMENT
*
*		   IF OPERATING ON THE SECOND OPERAND AND IT IS A
*		   SELF DEFINING TERM, THEN FLAG 'IMMEDIATE DATA'
*		   IN THE OPERATION CODE WORD (BIT 0 = 1).
*
*		   OTHERWISE, IF THE OPERAND IS AN INDEX REGISTER,
*		     1) SET 'IXYES' = 1,
*		     2) INITIALIZE INDEX REGISTER FLAG, AND
*		     3) STORE THE INDEX REGISTER VALUE IN THE 'SLE'.
*
*	 NORMAL AND OPERAND HAS TWO SUBLIST ELEMENTS
*
*		   STORE DATA REPRESENTED BY THE FIRST SUBLIST ELEMENT
*		   IN THE OPERAND FIELD.
*
*		   SET THE OPERATION CODE FLAG BITS TO PROPERLY
*		   REFELCT THE INDEX REGISTER SPECIFICATION.
*
*		     BITS 6 & 7 FOR OPERAND 1  #1 = '01'  #2 = '10'
*		     BITS 4 & 5 FOR OPERAND 2	      DITTO
*		     BITS 2 & 3 FOR OPERAND 3	      DITTO
*
*	 ABNORMAL
*		   ERROR MESSAGE NO. 4 WILL BE GENERATED IF THE NUMBER
*		   OF OPERAND SUBLIST ELEMENTS IS NOT 1 OR 2.
*
*		   ERROR MESSAGE NO. 5 WILL BE GENERATED IF AN INDEX
*		   REGISTER OTHER THAN #1 OR #2 IS SPECIFIED.
*
*  REGISTERS USED
*     #2 IS USED
*
	 EJECT
	 MOVE	   #2,OTE#
	 MOVE	   (OTETYPE,#2),+#ADDRESS
*
	 MOVE	   #2,#OP
	 GOTO  ($INDXER1,$INDEX1,$INDEX2),(OLESLE#,#2)
	 SPACE 3
*  '$INDEX1' PROCESSES OPERANDS WITH ONLY ONE SUBLIST ELEMENT
*
$INDEX1  EQU   *
	 MOVE  #2,(OLESLE,#2)
*
	 IF    ((SLETYPE,#2),EQ,+SELFDEF),AND,(OP#,EQ,2)
	   IOR	 #OPWORD,X'8000'
	 ELSE
	   MOVE      #2,#OP
	   IF	 ((OLELENG,#2),EQ,2)
	     MOVE	 #2,(OLEDATA,#2)
*
	     IF        ((0,#2),EQ,REG1,2)
	       MOVE	 SLE#X,0
	     ELSE
	       IF	 ((0,#2),NE,REG2,2),GOTO,$INDEX4
	       MOVE	 SLE#X,2
	     ENDIF
*
	     MOVE      #2,#OP
	     MOVE      #2,OTE#
	     MOVE      (OTETYPE,#2),+#INDXREG
	     MOVE      (OTEDATAP,#2),1,P2=SLE#X
	     MOVE      IXYES,1
	     MOVE      $INDEXWK,X'00C0'
	     GOTO      $INDEX3
	   ENDIF
	 ENDIF
*
	 GOTO  $INDEX4
	 EJECT
	 SPACE 3
*  '$INDEX2' PROCESSES OPERANDS WITH TWO SUBLIST ELEMENTS
*
$INDEX2  EQU   *
	 MOVE  #2,(OLESLE,#2)
	 ADD   #2,+LSLE
	 IF    ((SLELENG,#2),EQ,2)
	   MOVE      #2,(SLEDATA,#2)
	   IF	 ((0,#2),EQ,REG1,2)
	     MOVE      $INDEXWK,X'0040'
	   ELSE
	     IF    ((0,#2),EQ,REG2,2)
	       MOVE	 $INDEXWK,X'0080'
	     ELSE
	       GOTO	 $INDXER2
	     ENDIF
	   ENDIF
	 ELSE
	   GOTO      $INDXER2
	 ENDIF
*
$INDEX3  EQU   *
	 ADD   OP#,OP#,RESULT=$INDEXC
	 SHIFTL    $INDEXWK,1,P2=$INDEXC
	 IOR   #OPWORD,1,P2=$INDEXWK
*
$INDEX4  EQU   *
	 RETURN
	 SPACE 2
$INDXER1 EQU	   *
	 ASMERROR  4
*
$INDXER2 EQU	   *
	 ASMERROR  5
*
REG1	 DC	   CL2'#1'
REG2	 DC	   CL2'#2'
*
IXYES	 DC	   F'0'
	 EJECT
