**************************************************************
*							     *
*     CDRRM -- RMU RECORD DESCRIPTION			     *
*							     *
*  5719-LM7 COPYRIGHT IBM CORP 1980			     *
*  5740-LM4 COPYRIGHT IBM CORP 1980			     *
*  LICENSED MATERIAL - PROGRAM PROPERTY OF IBM		     *
*  REFER TO COPYRIGHT INSTRUCTIONS FORM #G120-2083	     *
*							     *
*  EQUATES DEFINING FORMAT OF TEXT RECORDS USED FOR RMU.     *
*							     *
*  CHANGE ACTIVITY					     *
*    DATE   APAR/DPAR  ID.   SUMMARY OF CHANGES		     *
*   4/10/80  V3M0 DRL  DRL  LARGE DATA SETS (COMMENT CHANGE  *
*			    ONLY)			     *
*   8/22/80  S201352   DRL  ADD STATUS CODE INDICATING ENQT  *
*			    FAILED			     *
*							     *
*   3/03/81  S203475   VSM  ADD SUPPORT FOR SHIPPING DME     *
*			    INFO WITH PROGRAM		     *
*							     *
**************************************************************
*
RM	 EQU   0
*
RMH	 EQU   0		  HEADER
RMHBSCC  EQU   0       X'1002'	  BSC CONTROL CHARS (DLE/ETX)
RMHID	 EQU   2       C'X'	  HEADER ID (IDENTIFIES EDX/RMU
RMHIDX	 EQU   C'X '
RMHTYP	 EQU   3       CL1	  HEADER TYPE
RMHTYPR  EQU   C'R '		    R REQUEST
RMHTYPS  EQU   C'S '		    S STATUS
RMHTYPC  EQU   C'C '		    C COUNT
RMHTYPD  EQU   C'D '		    D DATA
RMHTYPP  EQU   C'P '		    P PASSTHRU
*
RMHX	 EQU   4		  EXTENSION AFTER HEADER
*
*
*	 RECORD TYPE: REQUEST
*
RMREQ	 EQU   RMHX+0  F	  REQUEST TYPE
RMREQSND EQU   0		    0 SEND
RMREQRCV EQU   1		    1 RECEIVE
RMREQALC EQU   2		    2 ALLOCATE
RMREQDEL EQU   3		    3 DELETE
RMREQDMP EQU   4		    4 DUMP
RMREQWRP EQU   5		    5 WRAP
RMREQIDC EQU   6		    6 IDCHECK
RMREQSHT EQU   7		    7 SHUTDOWN
RMREQEXC EQU   9		    9 EXEC
RMREQPST EQU   12		   12 PASSTHRU
*
RMRX	 EQU   RMHX+2		  REQUEST EXTENSION
*
*	 EXTENSION: SEND
*
RMSDSN	 EQU   RMRX+0  CL8	  DATA SET NAME
RMSVOL	 EQU   RMRX+8  CL6	  VOLUME NAME (BLANK=IPL VOLUME)
RMSSTR	 EQU   RMRX+14 D	  STARTING RECORD OF DATA SET
RMSTYP	 EQU   RMRX+18 F	  TYPE OF SEND
RMSTYPN  EQU   0		  0 NORMAL (256-BYTE RECORDS,
*				    POSSIBLY BLOCKED)
RMSTYPS  EQU   1		  1 SOURCE (80-BYTE RECORDS,
*				    POSSIBLY BLOCKED)
RMSBLK	 EQU   RMRX+20 F	  BLOCKING FACTOR (0 OR 1=NO BLOCKING)
*
*	 EXTENSION: RECEIVE
*
RMRDSN	 EQU   RMRX+0  CL8	  DATA SET NAME
RMRVOL	 EQU   RMRX+8  CL6	  VOLUME NAME (BLANK=IPL VOLUME)
RMRSTR	 EQU   RMRX+14 D	  STARTING RECORD OF DATA SET
RMRTYP	 EQU   RMRX+18 F	  TYPE OF RECEIVE
RMRTYPN  EQU   0		    0 NORMAL (256-BYTE RECORDS,
*				      POSSIBLY BLOCKED)
RMRTYPS  EQU   1		    1 SOURCE (80-BYTE RECORDS,
*				      POSSIBLY BLOCKED)
RMRBLK	 EQU   RMRX+20 F	  BLOCKING FACTOR (0 OR 1=NO BLOCKING)
*
*	 EXTENSION: ALLOCATE
*
RMADSN	 EQU   RMRX+0  CL8	  DATA SET NAME
RMAVOL	 EQU   RMRX+8  CL6	  VOLUME NAME (BLANK=IPL VOLUME)
RMANREC  EQU   RMRX+14 D	  NUMBER OF 256-BYTE RECORDS
RMADST	 EQU   RMRX+18 F	  DATA SET TYPE
RMADSTU  EQU   0		    0 UNDEFINED
RMADSTD  EQU   1		    1 DATA
RMADSTP  EQU   3		    3 PROGRAM
*
RMALAD	 EQU   RMRX+20		  LOAD ADDRESS			S203475
RMAPSZ	 EQU   RMRX+22		  PGM SIZE			S203475
RMAENT	 EQU   RMRX+24		  ENTRY POINT			S203475
RMARLD	 EQU   RMRX+26		  RLD COUNT			S203475
*	 EXTENSION: DELETE
*
RMDDSN	 EQU   RMRX+0  CL8	  DATA SET NAME
RMDVOL	 EQU   RMRX+8  CL6	  VOLUME NAME
*
*	 EXTENSION: DUMP
*
RMDPDSN  EQU   RMRX+0  CL8	  DATA SET NAME
RMDPVOL  EQU   RMRX+8  CL6	  VOLUME NAME (BLANK=IPL VOLUME)
*		       H	  (UNUSED)
RMDPPTN  EQU   RMRX+15 H	  PARTITION NUMBER (-1=RMU PTN,
*				    1-8 = SPECIFIC PTN)
*
*	 EXTENSION: WRAP
*
RMWTXT	 EQU   RMRX+0  C	  WRAP TEXT (MAY BE ANY LENGTH)
*
*	 EXTENSION: IDCHECK
*
RMICHK	 EQU   RMRX+0  CL8	  ID OF HOST
*
*	 EXTENSION: SHUTDOWN
*
*		       F	  (UNUSED)
RMSDFLG  EQU   RMRX+2  H	  FLAG
RMSDFLGX EQU   X'80'		  PROGRAM TO BE EXECUTED
RMSDFLGL EQU   X'40'		  LOGMSG=YES
RMSDPTN  EQU   RMRX+3  H	  PARTITION NUMBER (-1=RMU PTN,
*				    0=ANY PTN, 1-8=SPECIFIC PTN)
RMSDPGM  EQU   RMRX+4  CL8	  PROGRAM (DATA SET NAME)
RMSDVOL  EQU   RMRX+12 CL6	  VOLUME NAME (BLANK=IPL VOLUME)
RMSDLFS  EQU   RMRX+18 F	  FREE SPACE PASSED TO PROGRAM (BYTES)
RMSDPRM# EQU   RMRX+20 F	  NUMBER OF PARAMETER WORDS
RMSDPRM  EQU   RMRX+22 NF	  PARAMETER WORDS
RMSDDS#  EQU   RMRX+24 F	  NUMBER OF DATA SET NAMES PASSED
RMSDDS	 EQU   RMRX+26 NF	  DATA SET NAMES (DATA SET, VOLUME,
*				    BLANK VOLUME=IPL VOLUME)
*
*	 EXTENSION: EXEC
*
*		       F	  (UNUSED)
RMXFLG	 EQU   RMRX+2  H	  FLAG
RMXFLGL  EQU   X'40'		    LOGMSG=YES
RMXFLGW  EQU   X'20'		    WAIT=YES
RMXPTN	 EQU   RMRX+3  H	  PARTITION NUMBER (-1=RMU PTN,
*				    0=ANY PTN, 1-8=SPECIFIC PTN)
RMXPGM	 EQU   RMRX+4  CL8	  PROGRAM (DATA SET NAME)
RMXVOL	 EQU   RMRX+12 CL6	  VOLUME NAME (BLANK=IPL VOLUME)
RMXLFS	 EQU   RMRX+18 F	  FREE SPACE PASSED TO PROGRAM (BYTES)
RMXPRM#  EQU   RMRX+20 F	  NUMBER OF PARAMETER WORDS
RMXPRM	 EQU   RMRX+22 NF	  PARAMETER WORDS
RMXDS#	 EQU   RMRX+24 F	  NUMBER OF DATA SET NAMES PASSED
RMXDS	 EQU   RMRX+26 NF	  DATA SET NAMES (DATA SET, VOLUMES;
*				    BLANK VOLUME=IPL VOLUME)
*
*	 EXTENSION: PASSTHRU
*
RMPRBLK  EQU   RMRX+0  F	  BLOCKING FOR RECORDS FROM REMOTE
*				    (0=NONE; OTHER=LARGEST BLOCK
*				    HOST CAN RECEIVE)
RMPRFLG  EQU   RMRX+2  H	  FLAG (UNUSED)
RMPRPTN  EQU   RMRX+3  H	  PARTITION NUMBER (-1=RMU PTN,
*				    0=ANY PTN, 1-8=SPECIFIED PTN)
RMPRPGM  EQU   RMRX+4  CL8	  PROGRAM (DATA SET NAME)
RMPRVOL  EQU   RMRX+12 CL6	  VOLUME NAME (BLANK=IPL VOLUME)
RMPRLFS  EQU   RMRX+18 F	  FREE SPACE PASSED TO PROGRAM (BYTES)
RMPRPRM# EQU   RMRX+20 F	  NUMBER OF PARAMETER WORDS
RMPRPRM  EQU   RMRX+22 F	  PARAMETER WORDS
RMPRDS#  EQU   RMRX+24 F	  NUMBER OF DATA SET NAMES PASSED
RMPRDS	 EQU   RMRX+26 CL8,CL6	  DATA SET NAMES (DATA SET, VOLUME;
*				    BLANK VOLUME=IPL VOLUME)
*
*	 RECORD TYPE: STATUS
*
RMSREQ	 EQU   RMHX+0  F	  REQUEST TYPE
RMSFN	 EQU   RMHX+2  F	  FUNCTION
*
RMSFNOK  EQU   -1		  -1 OK; REQUEST SUCCESSFUL
*
*				  1 - 20:  RMU FUNCTION
*
RMSFNID  EQU   1		   1 IDCHECK FAILED
RMSFNBF  EQU   2		   2 BUFFER AREA TOO SMALL FOR RECORD
RMSFNSHR EQU   3		   3 SHORT RECORD (<4 BYTES)
RMSFNHIH EQU   4		   4 HEADER ID IS 'H' (INVALID)
RMSFNHID EQU   5		   5 INVALID HEADER ID (NOT 'X' OR 'H')
RMSFNRQX EQU   6		   6 REQUEST EXPECTED
RMSFNREQ EQU   7		   7 INVALID REQUEST
RMSFNRQS EQU   8		   8 REQUEST SHORT (MISSING INFO)
RMSFNSRT EQU   9		   9 INVALID SEND/RECEIVE TYPE
RMSFNBLF EQU   10		  10 INVALID BLOCKING FACTOR
RMSFNIM  EQU   11		  11 INVALID MSG RCVD DURING REQUEST
RMSFNPD  EQU   12		  12 INVALID PASSTHRU RECORD TYPE
RMSFNDPN EQU   13		  13 INVALID DUMP PARTITION NUMBER
RMSFNRQR EQU   14		  14 REQUEST RECEIVED WHILE ANOTHER
*				     RUNNING
RMSFNEOT EQU   15		  15 EOT EXPECTED AND NOT RECEIVED
RMSFNVTB EQU   16		  16 VIRTUAL TERMINAL BUSY
RMSFNVTE EQU   17		  17 VIRTUAL TERM ENQT FAILED  S201352
*
*				  21 - 30:  EDX FUNCTION (RMSST CON-
*					    TAINS RETURN CODE)
*
RMSFNR	 EQU   21		  21 READ DISK(ETTE) FAILED
RMSFNW	 EQU   22		  22 WRITE DISK(ETTE) FAILED
RMSFNL	 EQU   24		  24 LOAD FAILED
RMSFNLFP EQU   25		  25 LOAD OF OVERLAY FAILED
RMSFNBIO EQU   26		  26 BSC I/O FAILURE
RMSFNVTP EQU   27		  27 VIRT TERM PRINTEXT FAILED
*
*				  31 - 40:  EDX ADDITIONAL FUNCTION
*					    (RMSST CONTAINS RETURN
*					    CODE FROM $DISKUT3
*					    FOR CODES 31 -33)
*
RMSFNAD  EQU   31		  31 ALLOCATE/DELETE FAILED
RMSFNOPN EQU   32		  32 OPEN FAILED
RMSFNSED EQU   33		  33 SETEOD FAILED
RMSFNLDP EQU   34		  34 PARAMETERS TO BUILD "LOAD"
*				     INSTRUCTION ARE INVALID
*
*				  41 - 50:  RMU FUNCTION: RMU ERROR
*
RMSFNOFM EQU   41		  41 OVERLAY FUNCTION MISSING
*
RMSST	 EQU   RMHX+4  F	  STATUS OF FAILING FUNCTION
*				  (CONTAINS RETURN CODE IF SO
*				  INDICATED BY RMSFN)
RMSX	 EQU   RMHX+6		  STATUS EXTENSION
*
RMSLAD	 EQU   RMHX+8		  LOAD ADDRESS			S203475
RMSPSZ	 EQU   RMHX+10		  PGM SIZE			S203475
RMSENT	 EQU   RMHX+12		  ENTRY POINT			S203475
RMSRLD	 EQU   RMHX+14		  RLD  COUNT			S203475
*
*	 EXTENSION: IDCHECK STATUS
*
RMSRID	 EQU   RMSX+0  CL8	  ID OF REMOTE (RMU) SYSTEM
*
*	 RECORD TYPE: COUNT
*
RMCREQ	 EQU   RMHX+0  F	  REQUEST TYPE
RMCFLG	 EQU   RMHX+2  F	  FLAG
RMCFLGPD EQU   X'8000'		    PADDING OCCURRED
RMCCNT	 EQU   RMHX+4  D	  COUNT (NUMBER LOGICAL RECORDS)
RMCL	 EQU   RMHX+8		  LENGTH OF COUNT MSG
*
*	 RECORD TYPE: DATA
*
RMDDATA  EQU   RMHX+0  C	  DATA (VARIABLE LENGTH)
*
*	 RECORD TYPE: PASSTHRU
*
RMPTYP	 EQU   RMHX+0  F	  PASSTHRU TYPE
RMPTYPTX EQU   1		  TEXT OR PROGRAM FUNCTION KEY
RMPTYPRD EQU   2		  REQUEST FOR DATA
RMPTYPPE EQU   3		  PROGRAM END (DISCONNECT)
RMPTYPND EQU   4		  NO DATA
RMPX	 EQU   RMHX+2		  PASSTHRU EXTENSION
*
*	 PASSTHRU EXTENSION: TEXT OR PFK
*
RMPST	 EQU   RMPX+0  F	  STATUS OF LTERM MSG
RMPTXTL  EQU   RMPX+2  F	  TEXT LENGTH (BYTES) OR -1 IF PFK
RMPTXT	 EQU   RMPX+4  C	  TEXT (VARIABLE SIZE) IF LENGTH IS
*				  NOT -1
RMPPF	 EQU   RMPX+4  F	  PFK NUMBER (IF LENGTH IS -1)
*
*				  (THESE FIELDS MAY BE REPEATED
*				  FOR INPUT TO HOST IF BLOCKING
*				  IS REQUESTED. IF "RMPTXTL" IS
*				  ODD, ONE BYTE OF FILL FOLLOWS
*				  "RMPTXT").
*
