*START OF SPECIFICATIONS*************************************
* MODULE NAME = CMDEQU					    *
* DESCRIPTIVE NAME = GENERATE COMMAND EQUATED CONSTANTS     *
* COPYRIGHT = 5719-XS3 (C)  IBM CORP. 1979, 1981	    *  V3M1GRB
*	      REFER TO INSTRUCTIONS ON COPYRIGHT NOTICE     *
*	      FORM NO. G120-2083			    *
* CHANGE ACTIVITY = SEE BELOW				    *
*   VERSION = 03.0 MODIFIED				    *
* FUNCTION = GENERATE COMMAND EQUATED CONSTANTS		    *
* MODULE TYPE = MACRO					    *
* MACROS = NONE						    *
*END OF SPECIFICATIONS***************************************
*							   XS2020-00409
*  CHANGE HISTORY					   XS2020-00409
*   DATE     REASON  ID		    CHANGE SUMMARY
*							   XS2020-00409
* 02-01-80		  RECREATED FROM CMDTABLE MACRO    XS2020-00409
*							   XS2020-00409
* 02/26/80    V3M0   GDD  MADE ENQT AND DEQT SEPARATE OPERATION CODES
* 04/11/80    V3M0   LAC  ADDED PROLOGUE			V3M0LAC
* 05/01/80    PT00021	  ADD EDL LOOP INSTRUCTION - JWW	V3M0LAC
* 07/01/80    PT00633	  FIX $AND1R SO IT ASSEMBLES		V3M0LAC
* 07/22/80    PT00757	  REMOVE BSCEQU SO IT ASSEMBLES		V3M0HR
*								V3M0LAC
* 03/13/81    V3M1   GRB  ADD CF,LCC AND OP EXTENSION POINTER	V3M1GRB
* 04/08/81    PT00041GRB  SET EQU FOR	$DI   TO 5		PT00041
* 09/08/81    S203914JWW  ADD INDUSTRIAL AUTOMATION
*			  ADD USER EXTENSION POINTER
*********************************
*  EDX COMMAND TABLE (EQUATES)	*
*********************************
*
*  COMMANDS AVAILABLE TO THE USER				V3M1GRB
*
$RESERV1 EQU   1
$RESERV2 EQU   $RESERV1+1
*
*  EDX COMMANDS							V3M1GRB
*
*
*  COMMUNICATION FACILITY    CF					V3M1GRB
*
$S$EXEC  EQU   $RESERV2+1     CF CODE 3				V3M1GRB
$S$CMDTB EQU   $S$EXEC+1      CF CODE 4				V3M1GRB
*
*  SENSOR BASED I/0
*
$DI	 EQU   5		   DIGITAL INPUT  PT00041  XS2020-00409
$DIA	 EQU   $DI+1		   DIGITAL INPUT WITH ADDRESS
$DIX	 EQU   $DIA+1		   DIGITAL INPUT WITH INDEXING
$DIS	 EQU   $DIX+1		   DIGITAL INPUT EXTERNAL SYNC
$DO	 EQU   $DIS+1		   DIGITAL OUTPUT
$DOA	 EQU   $DO+1		   DIGITAL OUTPUT WITH ADDRESS
$DOX	 EQU   $DOA+1		   DIGITAL OUTPUT WITH INDEXING
$DOS	 EQU   $DOX+1		   DIGITAL OUTPUT EXTERNAL SYNC
$DOP	 EQU   $DOS+1		   DIGITAL OUTPUT PULSE
$AO	 EQU   $DOP+1		   ANALOGUE OUTPUT
$AOA	 EQU   $AO+1		   ANALOG OUTPUT WITH ADDRESS
$AOX	 EQU   $AOA+1		   ANALOG OUTPUT WITH INDEXING
$AI	 EQU   $AOX+1		   ANALOG INPUT
$AIA	 EQU   $AI+1		   ANALOG INPUT WITH ADDRESS
$AIX	 EQU   $AIA+1		   ANALOG INPUT WITH INDEXING
$AIS	 EQU   $AIX+1		   ANALOG INPUT SEQUENTIAL READ
*
*  TASK COMMUNICATION
*
$ATTACH  EQU   $AIS+1	      ATTACH TASK		   XS2020-00409
$DETACH  EQU   $ATTACH+1      DETACH TASK
$SWAIT	 EQU   $DETACH+1      WAIT FOR EVENT
$CWAIT	 EQU   $SWAIT+1       RESET EVENT, WAIT FOR EVENT
$POST	 EQU   $CWAIT+1       POST EVENT
$RESETEV EQU   $POST+1	      RESET EVENT
$SENQ	 EQU   $RESETEV+1     ENQUEUE FOR RESOURCE
$SDEQ	 EQU   $SENQ+1	      DEQUEUE RESOURCE
$ENDATTN EQU   $SDEQ+1	      RETURN FROM KEYBOARD TASK
*
*  STORAGE ALLOCATION
*
$GETMAIN EQU   $ENDATTN+1     OBTAIN MAIN STORAGE
$FREMAIN EQU   $GETMAIN+1     FREE MAIN STORAGE
*
*  DISK REQUEST
*
$DISKIO  EQU   $FREMAIN+1     READ/WRITE DISK
$LOAD	 EQU   $DISKIO+1      LOAD AN EDX PROGRAM
$PRGSTOP EQU   $LOAD+1	      STOP AN EDX PROGRAM
*
*  HOST COMMUNICATIONS
*
$TP	 EQU   $PRGSTOP+1     HOST COMMUNICATION SUPPORT   XS2020-00409
*
*  TERMINAL INPUT/OUTPUT AND CONTROL
*
$ENQTT	 EQU   $TP+2	      ENQUEUE A TERMINAL	       V3M0 GDD
$PRTEXT  EQU   $ENQTT+1     PRINTEXT SETUP 1 - OPERAND IS ADDR V3M0 GDD
$RDTEXTL EQU   $PRTEXT+1      READ TEXT LINE (WITH BLANKS)
$PRTNUM2 EQU   $RDTEXTL+1     PRINT NUMERIC DATA (WORD)
$PRTNUM4 EQU   $PRTNUM2+1     PRINT NUMERIC DATA (DBLWORD)
$PRSKPSP EQU   $PRTNUM4+1     PRINT SKIPS AND SPACES
$PRTIME  EQU   $PRSKPSP+1     PRINT DATE AND/OR TIME OF DAY
$GETVAL2 EQU   $PRTIME+1      READ NUMERIC DATA (WORD)
$GETVAL4 EQU   $GETVAL2+1     READ NUMERIC DATA (DBLWORD)
$YESNO	 EQU   $GETVAL4+1     BRANCH ON (Y)ES/(N)O RESPONSE
$RDTEXT  EQU   $YESNO+1       READ TEXT MESSAGE
$CURCTL  EQU   $RDTEXT+1      CURSOR CONTROL
$CURCTL1 EQU   $CURCTL+1      CTL STORE TRANSFER
*
*  ARITHMETIC OPERATIONS
*
$ADX222  EQU   $CURCTL1+1
$AD222	 EQU   $ADX222+1
$AD222C  EQU   $AD222+1
$SUX222  EQU   $AD222C+1
$SU222	 EQU   $SUX222+1
$SU222C  EQU   $SU222+1
$MU222	 EQU   $SU222C+1
$MU222C  EQU   $MU222+1
$DI222	 EQU   $MU222C+1
$DI222C  EQU   $DI222+1
*
$AD424	 EQU   $DI222C+1
$AD424C  EQU   $AD424+1
$SU424	 EQU   $AD424C+1
$SU424C  EQU   $SU424+1
$MU424	 EQU   $SU424C+1
$MU424C  EQU   $MU424+1
$DI424	 EQU   $MU424C+1
$DI424C  EQU   $DI424+1
*
$AD444	 EQU   $DI424C+1
$AD444C  EQU   $AD444+1
$SU444	 EQU   $AD444C+1
$SU444C  EQU   $SU444+1
$MU444	 EQU   $SU444C+1
$MU444C  EQU   $MU444+1
$DI444	 EQU   $MU444C+1
$DI444C  EQU   $DI444+1
*
$AD224	 EQU   $DI444C+1
$AD224C  EQU   $AD224+1
$SU224	 EQU   $AD224C+1
$SU224C  EQU   $SU224+1
$MU224	 EQU   $SU224C+1
$MU224C  EQU   $MU224+1
$DI224	 EQU   $MU224C+1
$DI224C  EQU   $DI224+1
*
$DI422	 EQU   $DI224C+1
$DI422C  EQU   $DI422+1
*
$AV222C  EQU   $DI422C+1
$AV424C  EQU   $AV222C+1
$AV444C  EQU   $AV424C+1
$AV224C  EQU   $AV444C+1
*
$MOV1	 EQU   $AV224C+1
$MOV1C	 EQU   $MOV1+1
$MOV2	 EQU   $MOV1C+1
$MOV2C	 EQU   $MOV2+1
$MOV4	 EQU   $MOV2C+1
$MOV4C	 EQU   $MOV4+1
*
*  LOGICAL OPERATIONS
*
*	 FOLLOWING LOGICAL OPERATIONS MUST BE ON A	       @PT00633
*	 4 WORD BOUNDARY				       @PT00633
$AND1R	 EQU   $MOV4C+1					       @PT00633
$AND1C	 EQU   $AND1R+1
$AND1	 EQU   $AND1C+1
$AND1CR  EQU   $AND1+1
$AND2R	 EQU   $AND1CR+1
$AND2C	 EQU   $AND2R+1
$AND2	 EQU   $AND2C+1
$AND2CR  EQU   $AND2+1
$AND4R	 EQU   $AND2CR+1
$AND4C	 EQU   $AND4R+1
$AND4	 EQU   $AND4C+1
$AND4CR  EQU   $AND4+1
$IOR1R	 EQU   $AND4CR+1
$IOR1C	 EQU   $IOR1R+1
$IOR1	 EQU   $IOR1C+1
$IOR1CR  EQU   $IOR1+1
$IOR2R	 EQU   $IOR1CR+1
$IOR2C	 EQU   $IOR2R+1
$IOR2	 EQU   $IOR2C+1
$IOR2CR  EQU   $IOR2+1
$IOR4R	 EQU   $IOR2CR+1
$IOR4C	 EQU   $IOR4R+1
$IOR4	 EQU   $IOR4C+1
$IOR4CR  EQU   $IOR4+1
$EOR1R	 EQU   $IOR4CR+1
$EOR1C	 EQU   $EOR1R+1
$EOR1	 EQU   $EOR1C+1
$EOR1CR  EQU   $EOR1+1
$EOR2R	 EQU   $EOR1CR+1
$EOR2C	 EQU   $EOR2R+1
$EOR2	 EQU   $EOR2C+1
$EOR2CR  EQU   $EOR2+1
$EOR4R	 EQU   $EOR2CR+1
$EOR4C	 EQU   $EOR4R+1
$EOR4	 EQU   $EOR4C+1
$EOR4CR  EQU   $EOR4+1
*
*  SHIFT INSTRUCTIONS
*
$SHR1R	 EQU   $EOR4CR+1
$SHR1C	 EQU   $SHR1R+1
$SHR1	 EQU   $SHR1C+1
$SHR1CR  EQU   $SHR1+1
$SHR2R	 EQU   $SHR1CR+1
$SHR2C	 EQU   $SHR2R+1
$SHR2	 EQU   $SHR2C+1
$SHR2CR  EQU   $SHR2+1
$SHR4R	 EQU   $SHR2CR+1
$SHR4C	 EQU   $SHR4R+1
$SHR4	 EQU   $SHR4C+1
$SHR4CR  EQU   $SHR4+1
$SHL1R	 EQU   $SHR4CR+1
$SHL1C	 EQU   $SHL1R+1
$SHL1	 EQU   $SHL1C+1
$SHL1CR  EQU   $SHL1+1
$SHL2R	 EQU   $SHL1CR+1
$SHL2C	 EQU   $SHL2R+1
$SHL2	 EQU   $SHL2C+1
$SHL2CR  EQU   $SHL2+1
$SHL4R	 EQU   $SHL2CR+1
$SHL4C	 EQU   $SHL4R+1
$SHL4	 EQU   $SHL4C+1
$SHL4CR  EQU   $SHL4+1
*
*  LOOP ORGANIZATION
*
$DOLOOP  EQU   $SHL4CR+1      INITIATE A 'DO' LOOP
$CONTINU EQU   $DOLOOP+1      END OF A LOOP
*
*  SUBROUTINE ORGANIZATION
*
$CALL	 EQU   $CONTINU+1      CALL SUBROUTINE
$RETURN  EQU   $CALL+1	      RETURN FROM SUBROUTINE
*
*  BRANCH INSTRUCTIONS
*
$GOTO	 EQU   $RETURN+1      UNCONDITIONAL BRANCH
$CGOTO	 EQU   $GOTO+1	      COMPUTED GOTO
$IFW	 EQU   $CGOTO+1       BRANCH ON CONDITION (WORD)
$IFB	 EQU   $IFW+1	      BRANCH ON CONDITION (BYTE)
$IFDW	 EQU   $IFB+1	      BRANCH ON CONDITION (DBL WORD)
*
$CMPRE	 EQU   $IFDW+1	      COMPARE - BRANCH IF EQUAL
$CMPRNE  EQU   $CMPRE+1       COMPARE - BRANCH IF NOT EQUAL
*
$FIND	 EQU   $CMPRNE+1      FIND BYTE EQUAL -  BRANCH IF NOT FOUND
$FINDNOT EQU   $FIND+1	      FIND BYTE NOT EQUAL - BRANCH NOT FOUND
*
*
*  TIMER INSTRUCTIONS
*
$STIMER  EQU   $FINDNOT+1     START SOFTWARE TASK TIMER
$WTIMER  EQU   $STIMER+1      WAIT FOR SOFTWARE TIMER
$INTTM	 EQU   $WTIMER+1      LOG TIME INTERVAL DATA
$INTTMX  EQU   $INTTM+1       LOG TIME INTERVAL DATA, INDEXED
$GETTIME EQU   $INTTMX+1      GET TIME AND DATE
*
*  EXECUTE USER EXIT ROUTINE
*
$USER	 EQU   $GETTIME+1     BRANCH TO USER EXIT ROUTINE
*
*  EXECUTE '$DEBUG' COMMANDS
*
$TESTIN  EQU   $USER+1
$TESTOUT EQU   $TESTIN+1
*
$EBCVT2  EQU   $TESTOUT+1     FORMAT CONVERSION
*
*  TERMINAL INPUT/OUTPUT AND CONTROL (NEW OP CODE)	       V3M0 GDD
*
$DEQTT	 EQU   $EBCVT2+1      DEQUEUE A TERMINAL	       V3M0 GDD
*
*  LOCAL COMMUNICATION CONTROLLER    (NEW OP CODE)	       V3M1GRB
*
$LCCENTR EQU   $DEQTT+1       LCC			       V3M1GRB
*
*  COMMAND EXTENSION					       V3M1GRB
*
$$OPEXT  EQU   $LCCENTR+1     OP EXTENSION		       V3M1GRB
*
* OPERATION CODE EXTENSION POINTER			       @S203914
$$OPUSER EQU   $$OPEXT+1				       @S203914
*							       @S203914
*** SPACE FOR ADDITIONAL COMMANDS***
*** RESERVED FOR FUTURE USE BY IBM***			       V3M1GRB
*
*							       @S203914
* INDUSTRIAL AUTOMATION OPCODE				       @S203914
*							       @S203914
$IAOPCD  EQU   212	      INDUSTRIAL AUTOMATION (SJRC)     @S203914
*							       @PT00021
$EDXLOOP EQU   213	      EDXLOOP CODE IS IN EDXALU        @PT00021
*							       @PT00021
*							       @PT00021
*  MOVE BYTE WITH COUNT ACROSS ADDRESS SPACE BOUNDARY
*
$MOVEXP  EQU   214
*
*  EXIO INSTRUCTIONS
*
$EXOPEN  EQU   215
$EXIO	 EQU   $EXOPEN+1
*
*  QUEUE INSTRUCTIONS
*
$QIO	 EQU   217	      QUEUE AND BUFFER
*
*  BSC ACCESS METHOD EQUATES  (USE 'COPY BSCEQU')
*
*  FLOATING POINT ARITHMETIC ROUTINES
*  COMMANDS EXTEND TO END OF COMMAND TABLE
*
$IFF	 EQU   219	      STANDARD PRECISION FLOATING COMPARE
$IFL	 EQU   $IFF+1	      EXTENDED PRECISION FLOATING COMPARE
*
$MFP4	 EQU   $IFL+1	      STANDARD PRECISION FLOATING MOVE
$MFP8	 EQU   $MFP4+1	      EXTENDED PRECISION FLOATING MOVE
*
$FPCONV  EQU   $MFP8+1	      FLOAT-INTEGER CONVERSION
*
$FA000	 EQU   $FPCONV+1      ADD
$FA001	 EQU   $FA000+1
$FA010	 EQU   $FA001+1
$FA011	 EQU   $FA010+1
$FA100	 EQU   $FA011+1
$FA101	 EQU   $FA100+1
$FA110	 EQU   $FA101+1
$FA111	 EQU   $FA110+1
$FS000	 EQU   $FA111+1       SUBTRACT
$FS001	 EQU   $FS000+1
$FS010	 EQU   $FS001+1
$FS011	 EQU   $FS010+1
$FS100	 EQU   $FS011+1
$FS101	 EQU   $FS100+1
$FS110	 EQU   $FS101+1
$FS111	 EQU   $FS110+1
$FM000	 EQU   $FS111+1       MULTIPLY
$FM001	 EQU   $FM000+1
$FM010	 EQU   $FM001+1
$FM011	 EQU   $FM010+1
$FM100	 EQU   $FM011+1
$FM101	 EQU   $FM100+1
$FM110	 EQU   $FM101+1
$FM111	 EQU   $FM110+1
$FD000	 EQU   $FM111+1       DIVIDE
$FD001	 EQU   $FD000+1
$FD010	 EQU   $FD001+1
$FD011	 EQU   $FD010+1
$FD100	 EQU   $FD011+1
$FD101	 EQU   $FD100+1
$FD110	 EQU   $FD101+1
$FD111	 EQU   $FD110+1
*
*  END OF COMMAND TABLE - LAST COMMAND CODE = X'FF'
*
	 EJECT
