	 TITLE '***  SUBROUTINE  CTS  ***'
*START OF SPECIFICATIONS*************************************
* MODULE NAME = CTS					    *
* DESCRIPTIVE NAME = PRINT CYLINDER, TRACK, AND SECTOR	    *
* COPYRIGHT = 5719-LM4 IBM CORP. 1979, 1980		    *
*	      REFER TO INSTRUCTIONS ON COPYRIGHT NOTICE     *
*	      FORM NO. G120-2083			    *
* CHANGE ACTIVITY = SEE BELOW				    *
*   VERSION = 03.0 REWRITTEN				    *
* FUNCTION = THIS COPY CODE COMPUTES AND PRINTS THE DISK OR *
*	     DISKETTE CYLINDER, TRACK, AND SECTOR NUMBER    *
*	     FOR A GIVEN EVENT DRIVEN EXECUTIVE RECORD	    *
* NOTES =  THIS COPY CODE IS USED BY THE EVENT DRIVEN	    *
*	   EXECUTIVE UTILITIES				    *
* MODULE TYPE = COPY CODE				    *
* MACROS = EVENT DRIVEN EXECUTIVE LANGUAGE		    *
*END OF SPECIFICATIONS***************************************
*
*  CHANGE HISTORY
*
*  V3M0LAC - 03-19-80 - VERSION 3 DEVELOPMENT
* S201369  - 08-21-80 - NSW  -	CTS INFORMATION INCORRECT
*  V3M1A   - 03-17-81 - CLK  -	4965 AND 1024 B/S ADDITIONS
*
*
*  CALLING SEQUENCE:
*
*	 CALL	 CTS,DSX,SCTR,REMAIN,EXFLAG
*
*	    WHERE:  DSX    = A DSCB POINTER, E.G. (DS1)
*		    SCTR   = RECORD NUMBER TO CONVERT TO CTS
*		    REMAIN = ADDRESS OF CALLING TASK
*		    EXFLAG = EXTENT INDICATOR (1=FIRST,2=SECOND)
*
	 SPACE 1
	 SUBROUT   CTS,#DSX,#SCTR,#REMAIN,#EXFLAG
*
*  COMPUTE SECTOR, TRACK, AND CYLINDER
*
	 MOVE	   #REGS,#1,2	   SAVE INDEX REGISTERS
	 MOVE	   #1,#DSX	   #1 = DATASET CONTROL BLOCK
	 MOVE	   #2,($DSCBVDE,#1) #2 = VOLUME DESCRIPTOR
	 MOVE	   CTSTMP2,($DSCBFLG,#1)  GET DSCB FLAGS	S201369
	 MOVE	   ABSREC,($DSCBORN,#1),DWORD ABSREC = DATASET BASE
*
	 MOVE	   #1,#SCTR	   #1 = ADDRESS OF RECORD NUMBER
*
	 ADD	   ABSREC,(0,#1),PREC=DD ABSREC = ABSOLUTE RECORD
*				   NUMBER
	 SUBTRACT  ABSREC,2,PREC=DS ADJUST FOR DATASET ORIGIN AND
*				   RECORD NUMBER DISPLACEMENTS
	 MOVE	   #1,#REMAIN	   #1 = TASK CONTROL BLOCK
	 MOVE	   CTSTMP1,($VOLTSZE,#2),FKEY=0 CTSTMP1 = RECORDS/TRACK
*
	 DIVIDE    ABSREC,CTSTMP1,PREC=DS DIVIDE BY RECORDS/TRACK
*
	 MOVE	   #SEC,($TCBCO,#1) #SEC = REMAINDER
	 MOVE	   CTSTMP1,($VOLCSZE,#2),FKEY=0 CTSTMP1 = TRACKS/
*				   CYLINDER
	 MOVE	   CTSTMP4,CTSTMP1    SAVE #TRACKS FOR LATER	S201369
	 AND	   CTSTMP2,X'2000',RESULT=CTSTMP3  GET FIXED HD S201369
	 IF	   (CTSTMP3,EQ,X'2000')   IF IT'S A FIXED HD	S201369
	   MOVE    CTSTMP1,8	   ALL FH'S HAVE 8 TRACKS	S201369
	 ENDIF							S201369
	 DIVIDE    ABSREC,CTSTMP1,PREC=DS DIVIDE BY TRACKS/CYLINDER
*
	 MOVE	   #TRK,($TCBCO,#1) #TRK = REMAINDER
	 MOVE	   #CYL,ABSREC+2   #CYL = QUOTIENT
*
*
*
	 MOVE	   CTSTMP2,($VOLFLAG,#2),FKEY=0 CTSTMP2 = VOLUME FLAGS
*
	 MOVE	   #2,($VOLDDB,#2),FKEY=0 #2 = DEVICE DATA BLOCK
*
	 MOVE	   CTSTMP1,($DDBTYPE,#2),FKEY=0 CTSTMP1 = DEVICE TYPE
*
	 IF	  (CTSTMP1,EQ,+D4964),OR,(CTSTMP1,EQ,+D4966),OR,       X
	       (CTSTMP1,EQ,+D4965)  IF 4964 OR 4966 OR 4965	  V3M1A
	   AND	  CTSTMP2,+$VOLSEC,RESULT=CTSTMP5  TEST SCT SIZE  V3M1A
	   IF	  (CTSTMP5,EQ,0) IF NOT 256 BYTE SECTORS	  V3M1A
		AND  CTSTMP2,+$VOLDNS	   TEST DENSITY		  V3M1A
		IF   (CTSTMP2,EQ,0) IF SINGLE DENSITY		  V3M1A
		     SHIFTL    #SEC,1  ADJUST FOR 128 BYTE SECTORS
		     ADD       #SEC,#EXFLAG ADD SECTOR OFFSET
		ELSE		  IF DOUBLE DENSITY		  V3M1A
		     SHIFTR    #SEC,2	  ADJUST FOR		  V3M1A
		     ADD       #SEC,1	    1024 BYTE SECTORS	  V3M1A
		ENDIF						  V3M1A
	   ELSE		      256 BYTE SECOTRS
		ADD  #SEC,1	 ADJUST SECTOR NUMBER
	   ENDIF
	 ENDIF
*								S201369
* ALL FIXED HEAD VOLUMES HAVE SPECIAL NUMBERING SCHEMES AND	S201369
* ALL 4963'S HAVE SPECIAL NUMBERING SCHEMES TOO			S201369
*								S201369
	 IF    (CTSTMP3,EQ,X'2000')   IF IT'S A FIXED HD VOL	S201369
	   IF  (CTSTMP1,EQ,+D4963)	AND ON A 4963		S201369
	     MOVE  #CYL,511		 CYL = 511		S201369
	     ADD   #TRK,16		 TRK = 16 - 23		S201369
	   ENDIF						S201369
	   IF  (CTSTMP1,EQ,+D4962F)	OR ON A 4962 FH		S201369
	     MOVE  #CYL,303		 CYL = 303		S201369
	   ENDIF						S201369
	 ELSE							S201369
	   IF	(CTSTMP1,EQ,+D4963)   IF ITS NOT A FH VOL	S201369
	     AND  CTSTMP2,X'0400'     GET FH DEVICE FLAG	S201369
	     IF   (CTSTMP2,EQ,X'0400')	YES,IT HAS FIXED HDS	S201369
	       ADD  #TRK,1		  HEAD 0 NOT USED	S201369
	       IF   (#TRK,GT,CTSTMP4)	  OVERFLOW?		S201369
		 ADD  #CYL,1		   BUMP CYL		S201369
		 MOVE #TRK,1		   SET TRK = 1		S201369
	       ENDIF						S201369
	     ENDIF						S201369
	   ENDIF						S201369
	 ENDIF							S201369
*
*
*  DISPLAY RESULT
*
	 DIVIDE    #CYL,100	   #CYL = FIRST CYLINDER DIGIT
	 IOR	   #CYL+1,X'F0',(1,BYTE),RESULT=CTSTEXT CONVERT TO
*				   EBCDIC
	 MOVE	   #CYL,($TCBCO,#1) #CYL = REMAINDER
	 DIVIDE    #CYL,10	   #CYL = SECOND CYLINDER DIGIT
	 IOR	   #CYL+1,X'F0',(1,BYTE),RESULT=CTSTEXT+1 CONVERT TO
*				   EBCDIC
	 IOR	   ($TCBCO+1,#1),X'F0',(1,BYTE),RESULT=CTSTEXT+2
*				   CONVERT THIRD CYLINDER DIGIT
	 DIVIDE    #TRK,10	   #TRK = FIRST TRACK DIGIT
	 IOR	   #TRK+1,X'F0',(1,BYTE),RESULT=CTSTEXT+3 CONVERT TO
*				   EBCDIC
	 IOR	   ($TCBCO+1,#1),X'F0',(1,BYTE),RESULT=CTSTEXT+4
*				   CONVERT SECOND TRACK DIGIT
	 DIVIDE    #SEC,10	   #SEC = FIRST SECTOR DIGIT
	 IOR	   #SEC+1,X'F0',(1,BYTE),RESULT=CTSTEXT+5 CONVERT TO
*				   EBCDIC
	 IOR	   (1,#1),X'F0',(1,BYTE),RESULT=CTSTEXT+6
*				   CONVERT SECOND SECTOR DIGIT
	 PRINTEXT  CTSTEXT
	 MOVE	   #1,#REGS,2	   RESTORE REGISTERS
	 RETURN
*
*  EQUATED CONSTANTS
*
D4964	 EQU	   X'0106'	   4964 DEVICE TYPE
D4965	 EQU	   X'5212'	   4965 DEVICE TYPE		V3M1A
D4966	 EQU	   X'0126'	   4966 DEVICE TYPE
D4963	 EQU	   X'3106'	   4963 DEVICE TYPE		S201369
D4962F	 EQU	   X'00BA'	   4962 DEVICE TYPE WITH FH	S201369
$VOLSEC  EQU	   X'0100'	   VOLUME DESCRIPTOR -- SECTOR FORMAT
$VOLDNS  EQU	   X'1000'	   VOLUME DESCRIPTOR -- DENSITY  V3M1A
*
*
*  DATA AREA
*
#REGS	 DATA	   2F'0'	   INDEX REGISTER SAVE AREA
CTSTEXT  TEXT	   LENGTH=7	   TEXT BUFFER
#CYL	 DATA	   F'0'		   CYLINDER NUMBER
#TRK	 DATA	   F'0'		   TRACK NUMBER
#SEC	 DATA	   F'0'		   SECTOR NUMBER
ABSREC	 DATA	   D'0'		   ABSOLUTE RECORD NUMBER
CTSTMP1  DATA	   F'0'
CTSTMP2  DATA	   F'0'
CTSTMP3  DATA	   F'0'		   FIXED HEAD WORK AREA		S201369
CTSTMP4  DATA	   F'0'		   FIXED HEAD WORK AREA		S201369
CTSTMP5  DATA	   F'0'		   1024 B/S WORK AREA		V3M1A
