	 TITLE '*** DDODEF ***'
*START OF SPECIFICATIONS*************************************
* MODULE NAME = DDODEF					    *
* DESCRIPTIVE NAME = DEFINE DATA AREAS FOR DCE AND DME	    *
* COPYRIGHT = 5719-LM4 IBM CORP. 1979, 1980		    *
*	      REFER TO INSTRUCTIONS ON COPYRIGHT NOTICE     *
*	      FORM NO. G120-2083			    *
* CHANGE ACTIVITY = SEE BELOW				    *
*   VERSION = 03.0 MODIFIED				    *
* FUNCTION = THIS MODULE DESCRIBES THE DATA AREAS	    *
*	     FOR A DATA MANAGEMENT DCE AND DME		    *
*	     MODULE DDODEFEQ CONTAINS EQUATES FOR THE	    *
*	     DCE,DME,FSE				    *
* NOTES =  THIS COPY CODE IS USED BY THE EVENT DRIVEN	    *
*	   EXECUTIVE UTILITIES				    *
* MODULE TYPE = COPY CODE				    *
* MACROS = EVENT DRIVEN EXECUTIVE LANGUAGE		    *
*END OF SPECIFICATIONS***************************************
*
* THE MODULE HAS BEEN COMPLETELY REARRANGED FOR VER. 3.0
*
* CHANGES:
*
* PT00011 - 04/29/80 - JWW - UPGRADE COMMENTS
* PT00071 - 05/02/80 - JWW - ADD PROLOGUE/COPYRIGHT
* PT00486 - 07/10/80 - JWW - ADD $EDXNUC SUFFIX
* @V3M1   - 01/06/81 - JWW - ADD FLAG BITS FOR MULTI-VOLUME DISKETTES
*
***********************************
*  DIRECTORY CONTROL ENTRY  (DCE) *
***********************************
*
$FPDS	 DATA	   D'0'    NO. RECORDS IN VOLUME OR DEVICE
$FPDE	 DATA	   D'0'    NO. FREE RECORDS IN VOLUME OR DEVICE
$FPDM	 DATA	   F'0'    NO. MEMBER ENTRIES
$FPDF	 DATA	   F'0'    NO. FREE SPACE ENTRIES
$FPDD	 DATA	   F'0'    NO. RECORDS IN DIRECTORY
$FPDB	 DATA	   F'0'    NO. UNUSED BYTES IN DIRECTORY
$FPDINIT DATA	   CL6'EDXEDX'	INITIALIZATION CHARACTERS
$FPDFLG  DATA	   F'0'    FLAGS:
*			   BIT 0 = RESERVED, MUST BE ZERO
*			   BIT 1 = 0 = NO WRITE VERIFY
*			   BIT 1 = 1 = WRITE VERIFY
*			   BIT 2 = 0 = FIXED HEAD AREA NOT ALLOCATED
*			   BIT 2 = 1 = FIXED HEAD AREA ALLOCATED
*				       VOLUME DIRECTORY ONLY
*			   BIT 3 = 0 = NOT A VOLUME DIRECTORY  @V3M1
*			   BIT 3 = 1 = VOLUME DIRECTORY        @V3M1
*			   BIT 4 = 0 = DISK		       @V3M1
*			   BIT 4 = 1 = DISKETTE		       @V3M1
*
$FPDIPL  DATA	   CL6' '  IPL VOLUME NAME...
*			   VOLUME DIRECTORY AND DISKETTE VOLUMES ONLY
$FPDNUC  DATA	   CL1' '  $EDXNUC SUFFIX
	 DATA	   XL1'0'  RESERVED, MUST BE ZERO
*********************************************
*  32 BYTES RESERVED FOR FIRST MEMBER ENTRY *
*********************************************
*
	 DATA	   16F'0'  RESERVED
***********************************
*  DIRECTORY MEMBER ENTRY  (DME)  *
***********************************
*
* THE FIRST FOUR(4) FIELDS ARE COMMON TO PROGRAMS, DATASETS, AND
* VOLUMES.
* THE REMAINING FIELDS HAVE A DIFFERENT USE - DEPENDING UPON
* WHETHER THE DME DESCRIBES A DATASET, PROGRAM, OR VOLUME.
*
* COMMON FIELDS:
*
$FPMN	 DATA	   CL8' '  MEMBER NAME IN EBCDIC
$FPMS	 DATA	   D'0'    RECORD DISPLACEMENT WITHIN DEVICE OR VOLUME
*			   TO THE FIRST RECORD OF THE MEMBER
$FPME	 DATA	   D'0'    RECORD DISPLACEMENT WITHIN DEVICE OR VOLUME
*			   TO THE LAST RECORD OF THE MEMBER
$FPMT	 DATA	   F'0'    MEMBER TYPE INDICATOR:
*			       X'0000' - UNDEFINED(RESERVED)
*			       X'0001' - DATA MEMBER
*			       X'0002' - UNDEFINED(RESERVED)
*			       X'0003' - PROGRAM MEMBER
*			       X'0004' - VOLUME(IN VOLUME DIR. ONLY)
*
* FIELDS USED FOR DATASETS AND PROGRAMS:
*
$FPML	 DATA	   F'0'    DATA MEMBER	  - RECORD LENGTH IN BYTES
*			   VOLUME MEMBER  - RECORD LENGTH IN BYTES
$FPMA	 EQU	   $FPML   PROGRAM MEMBER - LOAD ADDRESS
*********************************************
$FPMF	 DATA	   D'0'    DATA MEMBER - RECORD DISPLACEMENT
*			   WITHIN THE MEMBER TO PHYSICAL RECORD
*			   CONTAINING THE NEXT AVAILABLE
*			   LOGICAL RECORD
*			   VOLUME MEMBER  - RESERVED, MUST BE ZERO
$FPMB	 EQU	   $FPMF   PROGRAM MEMBER - SIZE IN BYTES
*********************************************
$FPMD	 DATA	   F'0'    DATA MEMBER - DISPLACEMENT IN BYTES
*			   WITHIN THE PHYSICAL RECORD FOR THE
*			   NEXT AVAILABLE LOGICAL RECORD OF THE
*			   DATA MEMBER
*			   VOLUME MEMBER  - RESERVED, MUST BE ZERO
$FPMP	 EQU	   $FPMD   PROGRAM MEMBER - ENTRY POINT ADDRESS
*********************************************
$FPMR	 DATA	   F'0'    PROGRAM MEMBER - SIZE OF RELOCATION
*			   DICTIONARY(RLD)
*			   DATA MEMBER	  - RESERVED, MUST BE ZERO
*			   VOLUME MEMBER  - RESERVED, MUST BE ZERO
*********************************************
*
* FLAGS AND RESERVED WORDS:
*
*********************************************
$FPMFLG  DATA	   F'0'    FLAGS:
*			   BIT 0 = 1 = EOD HAS BEEN SET
*			   BIT 0 = 0 = EOD HAS NOT BEEN SET
*			   BIT 1 = RESERVED, MUST BE ZERO
*			   BIT 2 = 1 = FIXED HEAD VOLUME
*			   BIT 2 = 0 = NOT FIXED HEAD VOLUME
*
	 DATA	   F'0'    RESERVED FOR SYSTEM USE
MESIZE	 DATA	   A(32)   SIZE OF MEMBER ENTRY
