	 TITLE '*** DDODEFEQ ***'
*START OF SPECIFICATIONS*************************************
* MODULE NAME = DDODEFEQ				    *
* DESCRIPTIVE NAME = DEFINE EQUATES FOR DCE AND DME	    *
* COPYRIGHT = 5719-LM4 IBM CORP. 1979, 1980		    *
*	      REFER TO INSTRUCTIONS ON COPYRIGHT NOTICE     *
*	      FORM NO. G120-2083			    *
* CHANGE ACTIVITY = SEE BELOW				    *
*   VERSION = 03.0 NEW					    *
* FUNCTION = THIS MODULE DESCRIBES THE DATA AREAS	    *
*	     FOR A DATA MANAGEMENT DCE,DME,FSE		    *
* NOTES =  THIS COPY CODE IS USED BY THE EVENT DRIVEN	    *
*	   EXECUTIVE UTILITIES				    *
* MODULE TYPE = COPY CODE				    *
* MACROS = EVENT DRIVEN EXECUTIVE LANGUAGE		    *
*END OF SPECIFICATIONS***************************************
*
* CHANGES:
*
* PT00011 - 04/29/80 - JWW - UPGRADE COMMENTS
* PT00071   05/02/80 - JWW - ADD PROLOGUE/COPYRIGHT
* PT00486   07/10/80 - JWW - ADD $EDXNUC SUFFIX
* @V3M1     01/06/81 - JWW - ADD FLAG BITS FOR MULTI-VOLUME DISKETTE
*
* NUMBERS IN PARENTHESES (X) INDICATE LENGTH OF FIELD IN BYTES...
*
***********************************
*  DIRECTORY CONTROL ENTRY  (DCE) *
***********************************
*
$$DCE	 EQU   *-*	    BEGINNING OF DCE
$$FPD	 EQU   $$DCE	    START FIRST FIELD
$$FPDS	 EQU   $$FPD+0	    NO. RECORDS IN VOLUME OR DEVICE (4)
$$FPDE	 EQU   $$FPDS+4     NO. FREE RECORDS IN VOLUME, OR DEVICE (4)
$$FPDM	 EQU   $$FPDE+4     NO. MEMBER ENTRIES	(2)
$$FPDF	 EQU   $$FPDM+2     NO. FREE SPACE ENTRIES (2)
$$FPDD	 EQU   $$FPDF+2     NO. RECORDS IN DIRECTORY (2)
$$FPDB	 EQU   $$FPDD+2     NO. UNUSED BYTES IN DIRECTORY (2)
$$FPDINT EQU   $$FPDB+2     INITIALIZATION CHARACTERS (6)
$$FPDFLG EQU   $$FPDINT+6   FLAGS: (2)
*			    BIT 0 = RESERVED, MUST BE ZERO
*			    BIT 1 = 0 = NO WRITE VERIFY
*			    BIT 1 = 1 = WRITE VERIFY
*			    BIT 2 = 0 = FIXED HEAD AREA NOT ALLOCATED
*			    BIT 2 = 1 = FIXED HEAD AREA ALLOCATED
*					(VOLUME DIRECTORY ONLY)
*			    BIT 3 = 0 = NOT A VOLUME DIRECTORY @V3M1
*			    BIT 3 = 1 = VOLUME DIRECTORY       @V3M1
*			    BIT 4 = 0 = DISK		       @V3M1
*			    BIT 4 = 1 = DISKETTE	       @V3M1
$$FPDIPL EQU   $$FPDFLG+2   IPL VOLUME NAME, (VOLUME DIRECTORY OR
*			    DISKETTE VOLUMES ONLY) (6)
$$FPDNUC EQU   $$FPDIPL+6   $EDXNUC SUFFIX, (VOLUME DIRECTORY OR
*			    DISKETTE VOLUMES ONLY) (1)
*	 EQU   $$FPDNUC+1   RESERVED, MUST BE ZERO (1)
$$FPDSIZ EQU   32	    LENGTH OF CONTROL ENTRY
*
***********************************
*  DIRECTORY MEMBER ENTRY  (DME)  *
***********************************
*
* THE FIRST FOUR(4) FIELDS ARE COMMON TO PROGRAMS, DATASETS, VOLUMES.
* THE REMAINING FIELDS HAVE A DIFFERENT USE - DEPENDING UPON
* WHETHER THE DME DESCRIBES A PROGRAM, DATASET, VOLUME.
*
* COMMON FIELDS:
*
$$DME	 EQU   *-*	    BEGINNING OF DME
$$FPM	 EQU   $$DME	    START FIRST FIELD
$$FPMN	 EQU   $$DME+0	    MEMBER NAME IN EBCDIC (8)
$$FPMS	 EQU   $$FPMN+8     RECORD DISPLACEMENT WITHIN DEVICE OR VOLUME
*			    TO THE FIRST RECORD OF THE MEMBER (4)
$$FPME	 EQU   $$FPMS+4     RECORD DISPLACEMENT WITHIN DEVICE OR VOLUME
*			    TO THE LAST RECORD OF THE MEMBER (4)
$$FPMT	 EQU   $$FPME+4     MEMBER TYPE INDICATOR: (2)
*			  X'0000' - UNDEFINED(RESERVED)
*			  X'0001' - DATA MEMBER
*			  X'0002' - UNDEFINED(RESERVED)
*			  X'0003' - PROGRAM MEMBER
*			  X'0004' - VOLUME(IN VOLUME DIR. ONLY)
*
$$FPMDAT EQU   X'0001'	    DATA TYPE
$$FPMPGM EQU   X'0003'	    PROGRAM TYPE
$$FPMVOL EQU   X'0004'	    VOLUME TYPE
*
* FIELDS USED FOR DATASETS AND PROGRAMS:
*
$$FPML	 EQU   $$FPMT+2     DATA MEMBER   -  RECORD LENGTH IN BYTES (2)
*			    VOLUME MEMBER -  RECORD LENGTH IN BYTES (2)
$$FPMA	 EQU   $$FPMT+2     PROGRAM MEMBER - LOAD ADDRESS (2)
***********************************
$$FPMF	 EQU   $$FPML+2     DATA MEMBER - RECORD DISPLACEMENT
*			    WITHIN THE MEMBER TO PHYSICAL RECORD
*			    CONTAINING THE NEXT AVAILABLE
*			    LOGICAL RECORD (4)
*			    VOLUME MEMBER - RESERVED, MUST BE ZERO (2)
$$FPMB	 EQU	$$FPML+2    PROGRAM MEMBER - SIZE IN BYTES (2)
***********************************
$$FPMD	 EQU	$$FPMB+4    DATA MEMBER - DISPLACEMENT IN BYTES
*			    WITHIN THE PHYSICAL RECORD FOR THE
*			    NEXT AVAILABLE LOGICAL RECORD OF THE
*			    DATA MEMBER (2)
*			    VOLUME MEMBER - RESERVED, MUST BE ZERO (2)
$$FPMP	 EQU	$$FPMB+4    PROGRAM MEMBER - ENTRY POINT ADDRESS
***********************************
$$FPMR	 EQU	$$FPMD+2    PROGRAM MEMBER - SIZE OF RELOCATION
*			    DICTIONARY(RLD)  2BYTE
*			    VOLUME MEMBER - RESERVED, MUST BE ZERO (2)
*******  EQU	$$FPMD+2    DATA MEMBER - UNUSED(RESERVED)
***********************************
*
* FLAGS AND RESERVED WORDS
*
***********************************
$$FPMFLG EQU	$$FPMR+2    FLAGS:    2BYTE
*			    BIT 0 = 1 = EOD HAS BEEN SET
*			    BIT 0 = 0 = EOD HAS NOT BEEN SET
*			    BIT 1 = RESERVED, MUST BE ZERO
*			    BIT 2 = 1 = FIXED HEAD VOLUME
*			    BIT 2 = 0 = NOT FIXED HEAD VOLUME
*******  EQU	$$FPMFLG+2  RESERVED FOR SYSTEM USE 2 BYTE
$$FPMSIZ EQU	32	    LENGTH OF DME
*
*****************************
*  FREE SPACE ENTRY  (FSE)  *
*****************************
*
$$FSE	 EQU	*-*	    BEGINNING OF FSE
$$FSEF	 EQU	$$FSE	    THE RECORD DISPLACEMENT, WITHIN THE
*			    VOLUME, TO THE FIRST RECORD OF FREE
*			    SPACE.
$$FSEL	 EQU	$$FSEF+4    THE RECORD DISPLACEMENT, WITHIN THE
*			    VOLUME, TO THE LAST RECORD OF FREE
*			    SPACE.
$$FSESIZ EQU	8	    LENGTH OF A SINGLE FSE
$$FSEFF  EQU	248	    OFFSET IN RECORD TO FIRST FSE ENTRY
