	 TITLE '*** ERRORDEF ***'
*START OF SPECIFICATIONS*************************************
* MODULE NAME = ERRORDEF				     *
* DESCRIPTIVE NAME = ERROR DEFINITIONS			     *
* COPYRIGHT = 5719-XX4 IBM CORP. 1980			     *
*	       REFER TO INSTRUCTIONS ON COPYRIGHT NOTICE     *
*	       FORM NO. G120-2083			     *
* CHANGE ACTIVITY = SEE BELOW				     *
*      04/10/80  VERSION 3.0 DEVELOPMENT		     *
*    VERSION = 03.0 MODIFIED				     *
*    DATE = MAY-07-1980					     *
* FUNCTION = THIS MODULE GENERATES ERROR CODE EQUATES	     *
* NOTES =   SEE LANGUAGE REFERENCE GUIDE FOR FUNCTION	     *
*	    DESCRIPTION, SYNTAX, AND SPECIAL CONSIDERATIONS. *
* MODULE TYPE = COPY CODE				     *
*    MODULE SIZE = N/A; EQUATES ONLY			     *
* MACROS = NONE						     *
*END OF SPECIFICATIONS***************************************
*
* CHANGES:
* S200190 - ADD ERROR CODE FOR DATA SET NOT OPEN(DSCBDDB = 0)
* @S1S1    - ADD ERROR CODE FOR SERIES/1 TO SERIES/1
* PT00071 - ADD PROLOGUE/COPYRIGHT INFO - JWW
* PT00482 - ADD ERROR CODE FOR CONTROL ADDRESS MARKER
* S202410 - ADD 2 NEW ERROR CODES FOR SERIES/1 - SERIES/1 - JWW
* PT00083 - ADD ERROR CODES FOR EXTENDED DELETED RECORD SUPPORT-JTB
*
*
*************************************
*    DISKIO ERROR CODES		    *
*************************************
ERROR00  EQU  -1 .  GOOD RETURN CODE
ERROR01  EQU   1 .  I/O ERROR AND NO DEVICE STATUS PRESENT
ERROR02  EQU   2 .  I/O ERROR TRYING TO READ DEVICE STATUS
ERROR03  EQU   3 .  RETRY COUNT EXHAUSTED WHEN TRYING TO RECOVER
*		    FROM AN I/O ERROR
ERROR04  EQU   4 .  ERROR ON ISSUING I/O INSTRUCTION TO READ DEVICE
*		    STATUS
ERROR05  EQU   5 .  UNRECOVERABLE I/O ERROR
ERROR06  EQU   6 .  ERROR ON ISSUING I/O INSTRUCTION FOR NORMAL I/O
ERROR07  EQU   7 .  A 'NO RECORD FOUND' CONDITION OCCURRED,
*		    A SEEK FOR AN ALTERNATE SECTOR WAS PERFORMED,
*		    AND ANOTHER 'NO RECORD FOUND' CONDITION OCCURRED,
*		    IE. NO ALTERATE IS ASSIGNED.
ERROR09  EQU   9 .  DEVICE WAS 'OFFLINE' WHEN I/O WAS REQUESTED
ERROR10  EQU  10 .  RECORD NUMBER OUT OF RANGE - MAY BE AN
*		      END OF DATA SET CONDITION
ERROR11  EQU  11 .  DEVICE WAS MARKED 'UNUSABLE' WHEN I/O WAS REQUESTED
ERROR12  EQU  12 .  DEVICE WAS NOT 'OPEN'... DDB ADDRESS = 0   S200190
ERROR13  EQU  13 .  CONTROL ADDRESS MARKER DETECTED WHEN       @PT00482
*		    DSCBFLG BIT 3= 0			       @PT00083
*		 ...REFERENCED SECTOR WAS NOT FORMATED AT 128  @PT00083
*		    BYTES/SECTOR OR THE REQUEST WAS FOR MORE   @PT00083
*		    THAN ONE 256 BYTE RECORD WHEN	       @PT00083
*		    DSCBFLG BIT 3= 1			       @PT00083
ERROR14  EQU  14 .  ONLY 1ST 128 BYTE SECTOR DELETED	       @PT00083
ERROR15  EQU  15 .  ONLY THE SECOND 128 BYTE SECTOR DELETED    @PT00083
ERROR16  EQU  16 .  BOTH 128 BYTE SECTORS WERE DELETED	       @PT00083
*************************************
*  COMMON SENSOR BASED ERROR CODES  *
*************************************
*
$OK	 EQU   -1		    GOOD COMPLETION
$SBBASE  EQU   90		    BASE ERROR VALUE
$SBISB	 EQU   $SBBASE+6	    BASE ERROR VALUE FOR ISB ERRORS
$DNA	 EQU   $SBBASE+0	    DEVICE NOT ATTACHED
$DNU	 EQU   $SBBASE+1	    BUSY OR DEVICE IN EXCLUSIVE USE
$BAR	 EQU   $SBBASE+2	    BUSY AFTER RESET
$CMDREJ  EQU   $SBBASE+3	    COMMAND REJECT
$INVREQ  EQU   $SBBASE+4	    INVALID REQUEST
$IDC	 EQU   $SBBASE+5	    INTERFACE DATA CHECK
$CTLBSY  EQU   $SBBASE+6	    CONTROLLER BUSY
$OVRVOLT EQU   $SBBASE+7	    AI OVER VOLTAGE
$INVRG	 EQU   $SBBASE+8	    AI INVALID RANGE
$RES1	 EQU   $SBBASE+9	    RESERVED
$INVCHA  EQU   $SBBASE+10	    AI INVALID CHANNEL
$INVCNT  EQU   $SBBASE+11	    INVALID COUNT FIELD
$BFRPFE  EQU   $SBBASE+12	    BUFFER PREVIOUSLY FULL OR EMPTY
$RES2	 EQU   $SBBASE+13	    RESERVED
$DCMDREJ EQU   $SBBASE+14	    DELAYED COMMAND REJECT
*************************************
*  LOADER ERROR CODES		    *
*************************************
LOADERR1 EQU   61 . THE TRANSIENT LOADER ($LOADER) DOES NOT EXIST
LOADERR2 EQU   62 . IN AN OVERLAY REQUEST, NO OVERLAY AREA EXISTS
LOADERR3 EQU   63 . IN AN OVERLAY REQUEST AND THE OVERLAY AREA
*			      IS IN USE
LOADERR4 EQU   64 . NO SPACE FOR TRANSIENT LOADER
LOADERR5 EQU   65 . IN AN OVERLAY LOAD OPERATION, THE NUMBER OF
*			      DATA SETS PASSED BY THE LOAD COMMAND
*			      DOES NOT EQUAL THE NUMBER REQUIRED
*			      BY THE OVERLAY PROGRAM
LOADERR6 EQU   66 . IN AN OVERLAY LOAD OPERATION, NO PARAMETERS WERE
*			      PASSED TO THE PROGRAM
LOADERR7 EQU   67 . A DISK I/O ERROR OCCURED DURING THE LOAD PROCESS
LODERR21 EQU   68 . LOAD OF MODULE CONTAINING GLOBAL REFERENCE @V3M1JHY
*		    BUT $SYSCOM NOT DEFINED IN SUPERVISOR      @V3M1JHY
*	       69 . RESERVED
LOADERR8 EQU   71 . PROGRAM NOT FOUND ON SPECIFIED VOLUME
LOADERR9 EQU   72 . DISK I/O ERROR WHILE READING DIRECTORY
LODERR10 EQU   73 . DISK I/O ERROR WHILE READING PROGRAM HEADER
LODERR11 EQU   74 . REFERENCED MODULE IS NOT A PROGRAM
LODERR12 EQU   75 . REFERENCED MODULE IS NOT A DATA SET
LODERR13 EQU   76 . DATA SET NOT FOUND ON REFERENCED VOLUME
LODERR14 EQU   77 . INVALID DATA SET NAME
LODERR15 EQU   78 . LOAD CMD DID NOT SPECIFY REQUIRED DATA SET(S)
LODERR16 EQU   79 . LOAD CMD DID NOT SPECIFY REQUIRED PARAMETER(S)
LODERR17 EQU   80 . INVALID VOLUME LABEL SPECIFIED (.GT. 8 CHAR, ETC.)
LODERR18 EQU   70 . NOT ENOUGH MAIN STORAGE FOR PROGRAM
LODERR19 EQU   81 . CROSS PARTITION LOAD REQUESTED AND
*		   SUPPORT DOES NOT EXIST
LODERR20 EQU   82 . REQUEST PARTITION NUMBER IS GREATER THAN THE
*		   NUMBER OF PARTITIONS IN THE SYSTEM
*	       83 .
*		. . RESERVED
*	       89 .
*************************************			    @S1S1
*  SERIES/1 TO SERIES/1 ERROR CODES *			    @S1S1
*************************************			    @S1S1
S1OK	 EQU   -1    .	   GOOD RETURN			    @S1S1
S1B10	 EQU   10    .	   BASE FOR ISB TYPE ERRORS	    @S1S1
S1B1000  EQU   1000  .	   BASE FOR OTHER ERRORS	    @S1S1
S1NOTACT EQU   1002  .	   OTHER SYSTEM NOT ACTIVE	    @S1S1
S1CHKER  EQU   1004  .	   CHKSUM ERROR ON DATA XFER	    @S1S1
S1INVOP  EQU   1006  .	   INVALID OPERATION OR SEQUENCE    @S1S1
S1TO	 EQU   1008  .	   TIMEOUT ERROR ON DATA XFER	    @S1S1
S1ABORT  EQU   1010  .	   TERMCTRL ABORT RECEIVED	    @S1S1
S1RESET  EQU   1012  .	   RESET ISSUED BY OTHER CPU	    @S1S1
S1INIT	 EQU   1014  .	   MICROCODE LOAD FAIL(DURING IPL)     @S202410
S1NULLI  EQU   1016  .	   INVALID OR UNSOLICITITED INTERRUPT  @S202410
S1ABORTN EQU   1050  .	   TERMCTRL ABORT & OTHER CPU NOT ACT. @S1S1
S1SLIPL  EQU   1052  .	   IPL ATTEMPTED BUT CPU NOT INITIALIZED @S1S1
S1INVLEN EQU   1054  .	   INVALID DATA LENGTH		    @S1S1
