	 TITLE	   'SUBROUTINE - ***** GETNAME *****'
*START OF SPECIFICATIONS*************************************
* MODULE NAME = GETNAME					    *
* DESCRIPTIVE NAME = ASKS FOR LIBRARY MEMBER NAME	    *
* COPYRIGHT = 5719-LM4 IBM CORP. 1979, 1980		    *
*	      REFER TO INSTRUCTIONS ON COPYRIGHT NOTICE     *
*	      FORM NO. G120-2083			    *
* CHANGE ACTIVITY = SEE BELOW				    *
*   VERSION = 03.0 MODIFIED				    *
* FUNCTION = SEE BELOW					    *
* NOTES =  THIS COPY CODE IS USED BY THE EVENT DRIVEN	    *
*	   EXECUTIVE UTILITIES				    *
* MODULE TYPE = COPY CODE				    *
* MACROS = EVENT DRIVEN EXECUTIVE LANGUAGE		    *
*END OF SPECIFICATIONS***************************************
***********************************************************************
*  SUBROUTINE TO ASK THE USER FOR A LIBRARY MEMBER NAME		      *
*								      *
*  INPUT PARAMETERS						      *
*	 GNMSG1  - THE ADDRESS OF A MESSAGE TO BE DISPLAYED TO	      *
*		   THE USER TO REQUEST INPUT.			      *
*	 GNDSCB  - THE ADDRESS OF THE 'DSCB' BEING OPENED	      *
*	 GNERRRET- THE ADDRESS OF THE FIRST INSTRUCTION OF	      *
*		   AN ERROR EXIT ROUTINE.			      *
*								      *
*								      *
*  NORMAL OUTPUT						      *
*	 1. THE REFERENCED 'DSCB' WILL HAVE BEEN OPENED.	      *
*	 2. THE DIRECTORY MEMBER ENTRY WILL HAVE BEEN SAVED	      *
*	    IN '$FPMS'.						      *
*	 3. THE NUMBER OF THE DIRECTORY ENTRY CONTAINING THE	      *
*	    MEMBER ENTRY WILL HAVE BEEN SAVED IN 'MERECORD'.	      *
*	 4. #1 AND #2 ARE RETURNED AS SET BY 'DSOPEN.		      *
*								      *
*  ERROR ACTIONS						      *
*	 1. FOR 'DATA SET NOT FOUND', THE USER WILL BE QUERIED	      *
*	    FOR A RETRY.  IF HE ELECTS NOT TO DO SO, A BRANCH	      *
*	    WILL BE TAKEN TO THE ADDRESS SPECIFIED BY 'GNERRRET'      *
*	 2. ALL OTHER ERROR EXIT ADDRESSES IN 'DSOPEN' MUST	      *
*	    HAVE BEEN FILLED IN BY THE CALLER PREVIOUSLY.	      *
*	 3. AN ATTEMPT TO OPEN A TAPE DATASET WILL BE REJECTED.       *
*								      *
*  OTHER MODULES REQUIRED					      *
*	 DDODEF							      *
*	 DSOPEN							      *
*								      *
***********************************************************************
* DATE	    APAR/DPAR ID   SUMMARY OF CHANGES			      *
*								      *
* 02/22/80  PT00474   NSW  TAPE DATASETS REJECTED.		      *
* 03/18/80  V3M0JWW   JWW  VERSION 3.0 DEVELOPMENT		      *
* 05/02/80  PT00071   JWW  ADD PROLOGUE/COPYRIGHT		      *
* 12/12/80  S202457   SAG  ADD FKEY TO MOVE SO CAN BE RUN IN PARTITION*
*			   OTHER THAN 1				      *
*								      *
***********************************************************************
	 EJECT
	 SUBROUT   GETNAME,GNMSG1,GNDSCB,GNERRRET
	 SPACE 3
$GN0	 EQU	   *
	 MOVEA	   $DSNFND,$GN3
	 ENQT
	 SPACE 1
$GN1	 EQU	   *
	 MOVE	   #1,GNDSCB
	 MOVE	   ($DSCBNAM,#1),X'4040',4  INITIALIZE DSCB
	 MOVE	   ($DSCBVOL,#1),X'4040',3
	 MOVE	   GNMSG2,GNMSG1
	 READTEXT  DSNVOL,*,P2=GNMSG2,PROMPT=COND
	 SPACE 1
	 IF	   (DSNVOL-1,EQ,0,BYTE),GOTO,$GN1
	 SPACE 1
*				       IF A ',' WAS ENTERED
	 FIND	   C',',DSNVOL,15,COMMAPTR,NOCOMMA
*				       .
	 MOVE	   MOVECNT1,COMMAPTR   . COMPUTE THE
	 MOVEA	   WORK1,DSNVOL        .  LENGTH OF THE DATA SET
	 SUBTRACT  MOVECNT1,1,P2=WORK1 .   NAME FIELD
*				       .
*				       . IF LENGTH IS VALID
	 IF	   (MOVECNT1,GE,1),AND,(MOVECNT1,LE,8)
*				       . .
*				       . . STORE NAME AND LENGTH
	   MOVE    ($DSCBNAM,#1),DSNVOL,(1,BYTE),P3=MOVECNT1
	   MOVE    ($DSCBNAM-1,#1),MOVECNT1+1,(1,BYTE)
*				       . .
*				       . . COMPUTE
	   MOVE     MOVECNT2+1,DSNVOL-1,(1,BYTE) THE
	   SUBTRACT MOVECNT2,MOVECNT1  . .	  LENGTH OF THE VOLUME
	   SUBTRACT MOVECNT2,1	       . .	   LABEL FIELD
*				       . .
*				       . . IF LENGTH IS VALID
	   IF	   (MOVECNT2,GE,1),AND,(MOVECNT2,LE,6)
*				       . . . STORE VOLUME LABEL
	   ADD	   COMMAPTR,1	       . . .
	   MOVE    ($DSCBVOL,#1),*,(1,BYTE),P2=COMMAPTR,P3=MOVECNT2
	   MOVE    ($DSCBVOL-1,#1),MOVECNT2+1,(1,BYTE)
********** MOVE    ($DSCBDDB,#1),0     . .			V3M0JWW
	   ELSE			       . . ELSE
*				       . . . PRINT ERROR MESSAGE
	   PRINTEXT 'INVALID VOLUME LABEL@'
	   GOTO      $GN4
	   ENDIF		       . . ENDIF
	 ELSE			       . ELSE
*				       . . PRINT ERROR MESSAGE
	   PRINTEXT 'INVALID NAME@',P1=INVNAME
	   GOTO      $GN4
	 ENDIF			       . ENDIF
*
	 GOTO  $GN2
	 SPACE 1
NOCOMMA  EQU	   *		       ELSE
	 MOVE	   MOVECNT3+1,DSNVOL-1,(1,BYTE)
*
	 IF	   (MOVECNT3,LE,8)     . IF LENGTH IS VALID
*				       . STORE DATA SET NAME AND LENGTH
	   MOVE    ($DSCBNAM,#1),DSNVOL,(1,BYTE),P3=MOVECNT3
	   MOVE    ($DSCBNAM-1,#1),MOVECNT3+1,(1,BYTE)
	   MOVE    ($DSCBVOL,#1),X'4040',3
********** MOVE    ($DSCBDDB,#1),0     . .		       V3M0JWW
	 ELSE			       . ELSE
*				       . . PRINT ERROR MESSAGE
	   PRINTEXT  INVNAME
	   GOTO      $GN4
	 ENDIF			       . ENDIF
	 GOTO  $GN2
	 SPACE 1
DSNVOL	 TEXT	   LENGTH=15
	 SPACE 1
$GN2	 EQU   *
	 DEQT
	 SPACE 1
*  LOOK FOR MEMBER NAME IN LIBRARY
*
	 MOVE	   DSCBADDR,GNDSCB
	 MOVE	   TAPE1,GNDSCB				       @02.0 W4
	 MOVE	   TAPE2,GNDSCB				       @02.0 W4
	 CALL	   DSOPEN,(*),P2=DSCBADDR
*************************************************	       @02.0 W4
*  IF ITS A TAPE DATASET, GIVE ERROR MSG AND	*	       @02.0 W4
*  REJECT THE REQUEST. THE TAPE DATASET MUST BE *	       @02.0 W4
*  CLOSED.					*	       @02.0 W4
*************************************************	       @02.0 W4
	 MOVE	 PTR474,#1	    SAVE #1		       @02.0 W4
	 MOVE	 #1,0,P2=TAPE1	    DSCB ADDR IN #1	       @02.0 W4
	 MOVE	 #1,($DSCBVDE,#1)   VDE POINTER IN #1 @V3M0JWW @02.0 W4
	 MOVE	 #1,($VOLDDB,#1),FKEY=0  DCB POINTER IN #1	     W4
*					      S202457 @V3M0JWW @02.0 W4
	 MOVE	 #1,(2,#1),FKEY=0   DEVICE ID IN #1	       @02.0 W4
	 IF	 (#1,EQ,X'3186')    IF ITS A TAPE	       @02.0 W4
	   PRINTEXT '@ERROR - TAPE VOLUMES NOT ALLOWED@'       @02.0 W4
TAPE2	   EQU	 *+10		    DSCB IN CONTROL INSTN      @02.0 W4
	   CONTROL  *,CLSRU	    CLOSE THE TAPE	       @02.0 W4
	   GOTO     $GN4	    RETRY?		       @02.0 W4
	 ENDIF			    +			       @02.0 W4
	 MOVE  #1,PTR474	    RESTORE #1		       @02.0 W4
	 SPACE 2
	 RETURN
	 SPACE 1
PTR474	 DC    F'0'		    SAVE AREA FOR #1	       @02.0 W4
	 SPACE 2
*  MEMBER NOT FOUND
*
$GN3	 EQU	   *
	 ENQT
	 MOVE	   #1,GNDSCB
	 PRINTEXT  ($DSCBNAM,#1)
	 PRINTEXT  ' NOT FOUND@'
	 DEQT
	 SPACE 1
$GN4	 EQU	   *
	 QUESTION  'RETRY?: ',YES=$GN0
	 GOTO	   (GNERRRET)
*
*	 END OF GETNMAE					       V3M0JWW
	 EJECT						       V3M0JWW
