	  TITLE  'SETEOD  **** COPY CODE SUBROUTINE  ****'
*******************************************************************
* SETEOD IS A COPY CODE SUBROUTINE WHICH UPDATES A MEMBER ENTRY   *
*  OF A DIRECTORY TO REFLECT THE LAST ACCESSED RELATIVE RECORD.   *
*
*  5719-LM7 COPYRIGHT IBM CORP 1979, 1980		       PT00070
*  5740-LM4 COPYRIGHT IBM CORP 1979, 1980		       PT00070
*  LICENSED MATERIAL - PROGRAM PROPERTY OF IBM		       PT00070
*  REFER TO COPYRIGHT INSTRUCTIONS FORM #G120-2083	       PT00070
*
*								  *
*  CALLING SEQUENCE :						  *
*								  *
*     CALL SETEOD,(DS1),(IOERROR)				  *
*								  *
*     WHERE DS1 IS THE NAME OF A PREVIOUSLY OPENED DSCB		  *
*	 AND IOERROR IS THE NAME OF A USER I/O ERROR		  *
*	 EXIT ROUTINE.						  *
*								  *
*  FUNCTION :  SETEOD IS USED TO UPDATE THE DIRECTORY OF A	  *
*	       TAPE OR DISK(ETTE) VOLUME TO REFLECT THE LAST	  *
*	       RELATIVE RECORD ACCESSED.			  *
*  METHOD :  IF TAPE THEN  CLOSE TAPE VIA CONTROL		  *
*	     ELSE						  *
*	     THE DATA SET CONTROL BLOCK DSCBNEX FIELD,		  *
*	     WHICH CONTAINS THE NEXT RECORD NUMBER FOR I/O	  *
*	     IS DECREMENTED BY ONE AND MOVED. THE DIRECTORY	  *
*	     ENTRY IS THEN READ VIA DSOPEN; THE DIRECTORY	  *
*	     ENTRY IS THEN UPDATED TO REFLECT THE LAST RELATIVE   *
*	     RECORD ACCESSED; THE DME IS WRITTEN TO THE DISK(ETTE)*
*	     THE INTEGRITY OF THE DIRECTORY IS PRESERVED BY	  *
*	     ENQUEUEING FOR THE VOLUME DIRECTORY ENTRY QCB.	  *
*								  *
* PREREQUISITES - DSOPEN MUST BE DEFINED IN THE SAME ASSEMBLY	  *
*		  THE DSOPEN FIELDS FOR I/O ERROR MUST BE	  *
*		  INITIALIZED TO FIELD OPEN ERRORS.		  *
*								  *
* INPUT: ADDRESS OF OPENED DSCB FOR WHICH END OF FILE IS TO BE SET*
* OUTPUT: IF TAPE  THEN TAPE CLOSED				  *
*	  ELSE							  *
*	  DIRECTORY MEMBER ENTRY REWRITTEN TO DISK(ETTE)	  *
*	  END OF DATA RELATIVE RECORD NUMBER IS SET IN THE	  *
*	    DIRECTORY MEMBER ENTRY AND DSCB. (DME AND DSCB)	  *
*	    #1 AND #2 REGISTERS ARE NOT PRESERVED.		  *
*	    DSCB ENTRIES SET: DSCBEND,DSCBFLAG			  *
*	    DME ENTRIES SET: $FPMF,$FPMFLG			  *
*								  *
* CHANGES: V3 DM ENHANCEMENTS 2/28/80 GRB V3M0GRB		  *
*		 ENTIRE DESCRIPTION REWRITTEN			  *
*	   ADD COPYRIGHT COMMENT 5/5/80 PTR00070  GRB		  *
*  PT00174 - 05-19-80 - SEGMENT DSOPEN CODE			PT00174
*  PT00276 - 05-28-80 - RESET DSCBNXT TO ITS CALLED VALUE	PT00276
*			AFTER CALL TO DSOPEN			  *
*  S203713 - 09-03-81 - CALL TO ENQVOL NEEDS 2ND PARAMETER  LVH   *
*  S203643 - 09-16-81 - UPDATE $DSCBEDB ($$FPMD) FIELD	    LVH   *
*								  *
*******************************************************************
	 SPACE 2
	 SUBROUT SETEOD,EODSCB,WDERROR
	 SPACE 2
	 MOVE	 #1,EODSCB	   POINT TO CALLER'S DSCB
	 SUBTRACT ($DSCBNEX,#1),1,RESULT=$BLOCK#,PREC=DSD LAST V3M0GRB
*				    RELATIVE RECORD ACCESSED   V3M0GRB
	 MOVE	  $LDISP,($DSCBEDB,#1)	 LOGICAL DISPLACEMENT	S203643
	 MOVE	  #2,($DSCBVDE,#1) POINT TO VDE   (DDE)        V3M0GRB
	 MOVE	  #2,($VOLDDB,#2),FKEY=0 DDB ADDR TO #2        V3M0GRB
	 SPACE	  2
*							       V3M0GRB
*	TAKE CARE OF TAPE FIRST				       V3M0GRB
*							       V3M0GRB
	 MOVE	  #1,($DDBTYPE,#2),FKEY=0   GET DEVICE ID      @02.0 W4
	 IF	  (#1,EQ,X'3186')     IF ITS A TAPE	       @02.0 W4
	   MOVE      #1,EODSCB		 GET THE DSCB ADDR     @02.0 C4
	   MOVE      ($DSCBLNG,#1),$BLOCK#,DWORD SET DS LENGTH V3M0GRB
	   MOVE      CONTROL+10,EODSCB	 GET THE DSCB ADDR     @02.0 C4
CONTROL    CONTROL   *-*,CLSRU,WAIT=YES  CLOSE THE TAPE        @02.0 W4
	   IF	     ((0,#1),NE,-1),AND, IF ERROR	       @02.0 C4X
	       (WDERROR,NE,0)		 AND ERROR RET ADDR    @02.0 C4
	      GOTO   (WDERROR)				       @02.0 W4
	   ENDIF					       @02.0 W4
	   RETURN			 ELSE RETURN	       @02.0 W4
	 ENDIF						       @02.0 W4
*							       V3M0GRB
*	 IF NOT TAPE, THEN HANDLE DISK(ETTE) .....	       V3M0GRB
*							       V3M0GRB
	 MOVE	 $EODSW,0	   INITIALIZE FOR NO ERROR     V3M0GRB
*							       V3M0GRB
*							       V3M0GRB
*S203713 CALL	  ENQVOL,EODSCB    ENQUEUE FOR THE DIRECTORY   V3M0GRB
	 CALL	  ENQVOL,EODSCB,0  ENQUEUE FOR THE DIRECTORY   S203713
*							       V3M0GRB
*							       V3M0GRB
	 SPACE	  1
	 MOVE	  EODSCB@,EODSCB   PASS DSCB@ TO OPEN CALL
	 CALL	  DSOPEN,(*),P2=EODSCB@  LOCATE MEMBER AND GET
*				   * DIRECTORY RECORD
	 MOVE	  $MEBLOCK,#1	   RBA OF DIRECTORY MEMBER ENTRY
	 IOR	  (DISKBUFR+$$FPMFLG,#2),X'8000' SET EOD FLAG  V3M0GRB
	 IF	  ($LDISP,NE,0)        ADJUST LAST FULL RECORD	S203643
	   SUBTRACT $BLOCK#,1,PREC=DS  POINTER IF NECESSARY	S203643
	 ENDIF							S203643
	 MOVE	  (DISKBUFR+$$FPMD,#2),$LDISP  UPDATE DISPL.	S203643
*				   IN DATA MEMBER ENTRY        V3M0GRB
	 MOVE	  (DISKBUFR+$$FPMF,#2),$BLOCK#,DWORD SET LAST  V3M0GRB
*			 RECORD ACCESSED IN DATA MEMBER ENTRY  V3M0GRB
	 IF	 ((DISKBUFR+$$FPMF,#2),EQ,$ZRO,DWORD) IF EMPTY V3M0GRB
	   MOVE  (DISKBUFR+$$FPMF,#2),$MNUS1,DWORD MARK EMPTY  V3M0GRB
	 ENDIF
	 SPACE	  1
WRCMD	 WRITE	  DS$,DISKBUFR,1,1,ERROR=$EODERR,P4=$MEBLOCK
	 SPACE	  1
$EODRETN EQU	  *
*							       V3M0GRB
*							       V3M0GRB
	 CALL	  DEQVOL,EODSCB    DEQUEUE THE DIRECTORY       V3M0GRB
*							       V3M0GRB
*							       V3M0GRB
	 MOVE	  #1,EODSCB	   POINT TO CALLER'S DSCB	S203643
	 MOVE	  ($DSCBEDB,#1),$LDISP RESTORE USER'S DISPL.	S203643
	 SPACE	  1
	 IF	  ($EODSW,NE,0),AND,(WDERROR,NE,0)	       V3M0GRB
	   GOTO     (WDERROR)
	 ENDIF
*S203643 MOVE	  #1,EODSCB	   POINT TO CALLER'S DSCB      V3M0GRB
	 IOR	  ($DSCBFLG,#1),X'8000' SET EOD FLAG IN DSCB   V3M0GRB
	 MOVE	  ($DSCBEND,#1),$BLOCK#,DWORD  SET EOD IN DSCB V3M0GRB
	 IF	 (($DSCBEND,#1),EQ,$ZRO,DWORD) IF DS IS EMPTY  V3M0GRB
	   MOVE  ($DSCBEND,#1),$MNUS1,DWORD MARK DS AS EMPTY   V3M0GRB
	 ENDIF
	 ADD	  $BLOCK#,1,RESULT=($DSCBNEX,#1),PREC=DSD SET  PT00276
*			    DSCBNEX TO VALUE AT CALL TIME      PT00276
	 RETURN			   RETURN TO CALLER
	 SPACE	  2
$EODERR  EQU	  *		   I/O ERROR HANDLER
	 MOVE	  $EODSW,1	   INDICATE I/O ERROR
	 GOTO	  $EODRETN
	 SPACE	  3
$BLOCK#  DATA	  D'0'		   PHYSICAL BLOCK NUMBER DW    V3M0GRB
$EODSW	 DATA	  F'0'		   WORK AREA
$ZRO	 DATA	  D'0'		   DW OF ZERO		       V3M0GRB
$MNUS1	 DATA	  D'-1'		   MINUS ONE		       V3M0GRB
$LDISP	 DATA	  F'0'		   LOGICAL DISPLACEMENT		S203643
	 TITLE	  ' '
